/*
 * HART Common Practice
 *
 *		@(#)common7.ddl	9.1 6/14/93
 */

//XXXX#include "macros.ddl"
//XXXX#include "bi_codes.h"

//XXXXMANUFACTURER  STANDARD, DEVICE_TYPE _COMMON_PRACTICE, DEVICE_REVISION 7, DD_REVISION 1
/* This file conforms to the document:
 *    HART Smart Communications Protocol - Common Practice Command Specification,
 *    Revision 7.0
 * This file conforms to the document:
 *    HART Smart Communications Protocol - Common Tables,
 *    Revision 6.0
 * This file conforms to the document:
 *    HART Smart Communications Protocol - Command Summary Information,
 *    Revision 7.0
 */

#ifdef XXXX
VARIABLE transmitter_variable_code_1
{
	HELP [index_into_dynamic_variables_array_1_help];
/*
	APPHELP "This is a handle, that is also an index assigned to a Field Device"
		" dynamic variable. It is used to access more variables that relate to"
		" that Field Device dynamic variable."
		" HART_VAR:SLOT #0 XMTR VAR CODE";
*/
	TYPE INDEX transmitter_variables;
	CLASS USER_INTERFACE;
}

VARIABLE transmitter_variable_code_2
{
	HELP [index_into_dynamic_variables_array_2_help];
/*
	APPHELP "This is a handle, that is also an index assigned to a Field Device"
		" dynamic variable. It is used to access more variables that relate to"
		" that Field Device dynamic variable."
		" HART_VAR:SLOT #1 XMTR VAR CODE";
*/
	TYPE INDEX transmitter_variables;
	CLASS USER_INTERFACE;
}

VARIABLE transmitter_variable_code_3
{
	HELP [index_into_dynamic_variables_array_3_help];
/*
	APPHELP "This is a handle, that is also an index assigned to a Field Device"
		" dynamic variable. It is used to access more variables that relate to"
		" that Field Device dynamic variable."
		" HART_VAR:SLOT #2 XMTR VAR CODE";
*/
	TYPE INDEX transmitter_variables;
	CLASS USER_INTERFACE;
}

VARIABLE transmitter_variable_code_4
{
	HELP [index_into_dynamic_variables_array_4_help];
/*
	APPHELP "This is a handle, that is also an index assigned to a Field Device"
		" dynamic variable. It is used to access more variables that relate to"
		" that Field Device dynamic variable."
		" HART_VAR:SLOT #3 XMTR VAR CODE";
*/
	TYPE INDEX transmitter_variables;
	CLASS USER_INTERFACE;
}

COMMAND read_transmitter_variables
{
	NUMBER 33;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{
			transmitter_variable_code_1 (INFO,INDEX),
			transmitter_variable_code_2 (INFO,INDEX),
			transmitter_variable_code_3 (INFO,INDEX),
			transmitter_variable_code_4 (INFO,INDEX)
		}

		REPLY
		{
			response_code, device_status,
			transmitter_variable_code_1,
			transmitter_variables[transmitter_variable_code_1].DIGITAL_UNITS,
			transmitter_variables[transmitter_variable_code_1].DIGITAL_VALUE,
			transmitter_variable_code_2,
			transmitter_variables[transmitter_variable_code_2].DIGITAL_UNITS,
			transmitter_variables[transmitter_variable_code_2].DIGITAL_VALUE,
			transmitter_variable_code_3,
			transmitter_variables[transmitter_variable_code_3].DIGITAL_UNITS,
			transmitter_variables[transmitter_variable_code_3].DIGITAL_VALUE,
			transmitter_variable_code_4,
			transmitter_variables[transmitter_variable_code_4].DIGITAL_UNITS,
			transmitter_variables[transmitter_variable_code_4].DIGITAL_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	MISC_ERROR,			[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		8,	MISC_WARNING,		[update_failure];
		16,	MODE_ERROR,			[access_restricted];
	}
}
#endif //XXXX

COMMAND write_pv_damping_value
{
	NUMBER 34;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			PV.DAMPING_VALUE
		}

		REPLY
		{
			response_code, device_status, PV.DAMPING_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		8,	DATA_ENTRY_WARNING,	[set_to_nearest_possible_value];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND write_pv_range_values
{
	NUMBER 35;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			PV.RANGE_UNITS(INFO), PV.UPPER_RANGE_VALUE, PV.LOWER_RANGE_VALUE
		}

		REPLY
		{
			response_code, device_status,
			PV.RANGE_UNITS(INFO), PV.UPPER_RANGE_VALUE, PV.LOWER_RANGE_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		9,	DATA_ENTRY_ERROR,	[lower_range_value_too_high];
		10,	DATA_ENTRY_ERROR,	[lower_range_value_too_low];
		11,	DATA_ENTRY_ERROR,	[upper_range_value_too_high];
		12,	DATA_ENTRY_ERROR,	[upper_range_value_too_low];
		13,	DATA_ENTRY_ERROR,	[URV_and_LRV_out_of_limits];
		14,	DATA_ENTRY_WARNING,	[span_too_small];
		16,	MODE_ERROR,			[access_restricted];
	}
}

#ifdef XXXX
COMMAND set_pv_upper_range_value
{
	NUMBER 36;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
			response_code, device_status
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		9,	PROCESS_ERROR,		[applied_process_too_high];
		10,	PROCESS_ERROR,		[applied_process_too_low];
		14,	DATA_ENTRY_WARNING,	[span_too_small];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND set_pv_lower_range_value
{
	NUMBER 37;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
			response_code, device_status
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		9,	PROCESS_ERROR,		[applied_process_too_high];
		10,	PROCESS_ERROR,		[applied_process_too_low];
		14,	DATA_ENTRY_WARNING,	[new_LRV_pushed_URV_over_USL];
		16,	MODE_ERROR,			[access_restricted];
	}
}
#endif //XXXX

COMMAND reset_configuration_change_flag
{
	NUMBER 38;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
			response_code, device_status
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,	[no_command_specific_errors];
		6,	MISC_ERROR, [xmtr_specific_command_error];
		7,	MODE_ERROR, [in_write_protect_mode];
		16,	MODE_ERROR, [access_restricted];
	}
}

VARIABLE eeprom_select
{
	HELP [eeprom_select_help];
/*
	APPHELP "For Burn requests, the Burn may not begin until the response that"
		" acknowledges the receipt of the variable has been sent back to the"
		" Master."
		" HART_VAR:EEPROM CONTROL";
*/
	LABEL [EEPROM_select];
	CLASS USER_INTERFACE;
	TYPE ENUMERATED
	{
		{ 0, [burn_eeprom] },
		{ 1, [restore_shadow_ram] }
	}
}

COMMAND eeprom_control
{
	NUMBER 39;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{
			eeprom_select
		}

		REPLY
		{
			response_code, device_status, eeprom_select
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND enter_exit_fixed_pv_current_mode
{
	NUMBER 40;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{
			PV.ANALOG_VALUE
		}
		REPLY
		{
			response_code, device_status, PV.ANALOG_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		11,	MODE_ERROR,			[in_multidrop_mode];
		16,	MODE_ERROR,			[access_restricted];
	}
}

#ifdef XXXX
COMMAND perform_transmitter_self_test
{
	NUMBER 41;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
			response_code, device_status
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,	[no_command_specific_errors];
		6,	MISC_ERROR, [xmtr_specific_command_error];
		16,	MODE_ERROR, [access_restricted];
	}
}
#endif

COMMAND perform_master_reset
{
	NUMBER 42;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
			response_code, device_status
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,	[no_command_specific_errors];
		6,	MISC_ERROR, [xmtr_specific_command_error];
		16,	MODE_ERROR, [access_restricted];
	}
}

#ifdef XXXX
COMMAND set_pv_zero
{
	NUMBER 43;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
			response_code, device_status
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,		[no_command_specific_errors];
		6,	MISC_ERROR,		[xmtr_specific_command_error];
		7,	MODE_ERROR,		[in_write_protect_mode];
		9,	PROCESS_ERROR,	[applied_process_too_high];
		10,	PROCESS_ERROR,	[applied_process_too_low];
		16,	MODE_ERROR,		[access_restricted];
	}
}
#endif //XXXX

COMMAND write_pv_units
{
	NUMBER 44;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			PV.DIGITAL_UNITS
		}

		REPLY
		{
			response_code, device_status, PV.DIGITAL_UNITS
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND trim_pv_current_dac_zero
{
	NUMBER 45;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{
			PV.ANALOG_VALUE
		}

		REPLY
		{
			response_code, device_status, PV.ANALOG_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		9,	MODE_ERROR,			[not_in_proper_current_mode];
		11,	MODE_ERROR,			[in_multidrop_mode];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND trim_pv_current_dac_gain
{
	NUMBER 46;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{
			PV.ANALOG_VALUE
		}

		REPLY
		{
			response_code, device_status, PV.ANALOG_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		9,	MODE_ERROR,			[not_in_proper_current_mode];
		11,	MODE_ERROR,			[in_multidrop_mode];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND write_pv_transfer_function
{
	NUMBER 47;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			PV.TRANSFER_FUNCTION
		}

		REPLY
		{
			response_code, device_status, PV.TRANSFER_FUNCTION
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		16,	MODE_ERROR,			[access_restricted];
	}
}

#ifdef XXXX //redefined
VARIABLE xmtr_specific_status_0
{
	HELP [field_device_status_0_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_0];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat1_1],MISC },
		{ 0x02, [fld_dev_stat1_2],MISC },
		{ 0x04, [fld_dev_stat1_3],MISC },
		{ 0x08, [fld_dev_stat1_4],MISC },
		{ 0x10, [fld_dev_stat1_5],MISC },
		{ 0x20, [fld_dev_stat1_6],MISC },
		{ 0x40, [fld_dev_stat1_7],MISC },
		{ 0x80, [fld_dev_stat1_8],MISC }
	}
}
#endif //XXXX
VARIABLE xmtr_specific_status_0
{
	HELP [field_device_status_0_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL "additional status 0|de|erweiterter Status 0";
	HANDLING READ;
STYLE "MULTILINE 32 4";
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, "Totalizer overflow|de|Zhlerberlauf", DATA & CORRECTABLE & DETAIL},
		{ 0x02, "MIN/MAX limit error|de|MIN/MAX unter-/berschritten", DATA & CORRECTABLE & DETAIL}
		{ 0x40, "A-B not monotonous ascending|de|Kennlinie A-B nicht monoton steigend", DATA & CORRECTABLE & DETAIL},
		{ 0x20, "Q(A-B) not monotonous ascending|de|Kennlinie Q(A-B) nicht monoton steigend", DATA & CORRECTABLE & DETAIL}
	}
}

#ifdef XXXX //redefined
VARIABLE xmtr_specific_status_1
{
	HELP [field_device_status_1_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_1];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat2_1],MISC },
		{ 0x02, [fld_dev_stat2_2],MISC },
		{ 0x04, [fld_dev_stat2_3],MISC },
		{ 0x08, [fld_dev_stat2_4],MISC },
		{ 0x10, [fld_dev_stat2_5],MISC },
		{ 0x20, [fld_dev_stat2_6],MISC },
		{ 0x40, [fld_dev_stat2_7],MISC },
		{ 0x80, [fld_dev_stat2_8],MISC }
	}
}
#endif //XXXX
VARIABLE xmtr_specific_status_1
{
	HELP [field_device_status_1_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL "additional status 1|de|erweiterter Status 1";
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
STYLE "MULTILINE 32 8";
	TYPE BIT_ENUMERATED
	{
		{ 0x01, "Floating body movement too small/large|de|Schwebekrperbewegung zu klein/gro", 	DATA & CORRECTABLE & DETAIL},
		{ 0x02, "PV > 103%", 	DATA & CORRECTABLE & DETAIL},
		{ 0x04, "PV out of limits|de|PV auerhalb der Grenzen", 	DATA & CORRECTABLE & DETAIL},
		{ 0x08, "DT>DTMAX,too cold|de|DT>DTMAX,zu kalt", 	DATA & CORRECTABLE & DETAIL},
		{ 0x10, "DT<DTMIN,too hot|de|DT<DTMIN,zu hei", 	DATA & CORRECTABLE & DETAIL},
		{ 0x20, "A-B negative|de|A-B negativ", 	DATA & CORRECTABLE & DETAIL},
		{ 0x40, "A out of range|de|A auerhalb Bereich", 	DATA & CORRECTABLE & DETAIL},
		{ 0x80, "B out of range|de|B auerhalb Bereich", 	DATA & CORRECTABLE & DETAIL}
	}
}

#ifdef XXXX

VARIABLE xmtr_specific_status_2
{
	HELP [field_device_status_2_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_2];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat3_1],MISC },
		{ 0x02, [fld_dev_stat3_2],MISC },
		{ 0x04, [fld_dev_stat3_3],MISC },
		{ 0x08, [fld_dev_stat3_4],MISC },
		{ 0x10, [fld_dev_stat3_5],MISC },
		{ 0x20, [fld_dev_stat3_6],MISC },
		{ 0x40, [fld_dev_stat3_7],MISC },
		{ 0x80, [fld_dev_stat3_8],MISC }
	}
}

VARIABLE xmtr_specific_status_3
{
	HELP [field_device_status_3_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_3];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat4_1],MISC },
		{ 0x02, [fld_dev_stat4_2],MISC },
		{ 0x04, [fld_dev_stat4_3],MISC },
		{ 0x08, [fld_dev_stat4_4],MISC },
		{ 0x10, [fld_dev_stat4_5],MISC },
		{ 0x20, [fld_dev_stat4_6],MISC },
		{ 0x40, [fld_dev_stat4_7],MISC },
		{ 0x80, [fld_dev_stat4_8],MISC }
	}
}

VARIABLE xmtr_specific_status_4
{
	HELP [field_device_status_4_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_4];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat5_1],MISC },
		{ 0x02, [fld_dev_stat5_2],MISC },
		{ 0x04, [fld_dev_stat5_3],MISC },
		{ 0x08, [fld_dev_stat5_4],MISC },
		{ 0x10, [fld_dev_stat5_5],MISC },
		{ 0x20, [fld_dev_stat5_6],MISC },
		{ 0x40, [fld_dev_stat5_7],MISC },
		{ 0x80, [fld_dev_stat5_8],MISC }
	}
}

VARIABLE xmtr_specific_status_5
{
	HELP [field_device_status_5_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_5];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat6_1],MISC },
		{ 0x02, [fld_dev_stat6_2],MISC },
		{ 0x04, [fld_dev_stat6_3],MISC },
		{ 0x08, [fld_dev_stat6_4],MISC },
		{ 0x10, [fld_dev_stat6_5],MISC },
		{ 0x20, [fld_dev_stat6_6],MISC },
		{ 0x40, [fld_dev_stat6_7],MISC },
		{ 0x80, [fld_dev_stat6_8],MISC }
	}
}

VARIABLE xmtr_specific_status_6
{
	HELP [field_device_status_14_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_14];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat15_1],MISC },
		{ 0x02, [fld_dev_stat15_2],MISC },
		{ 0x04, [fld_dev_stat15_3],MISC },
		{ 0x08, [fld_dev_stat15_4],MISC },
		{ 0x10, [fld_dev_stat15_5],MISC },
		{ 0x20, [fld_dev_stat15_6],MISC },
		{ 0x40, [fld_dev_stat15_7],MISC },
		{ 0x80, [fld_dev_stat15_8],MISC }
	}
}

VARIABLE xmtr_specific_status_7
{
	HELP [field_device_status_15_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_15];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat16_1],MISC },
		{ 0x02, [fld_dev_stat16_2],MISC },
		{ 0x04, [fld_dev_stat16_3],MISC },
		{ 0x08, [fld_dev_stat16_4],MISC },
		{ 0x10, [fld_dev_stat16_5],MISC },
		{ 0x20, [fld_dev_stat16_6],MISC },
		{ 0x40, [fld_dev_stat16_7],MISC },
		{ 0x80, [fld_dev_stat16_8],MISC }
	}
}

VARIABLE xmtr_specific_status_8
{
	HELP [field_device_status_16_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_16];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat17_1],MISC },
		{ 0x02, [fld_dev_stat17_2],MISC },
		{ 0x04, [fld_dev_stat17_3],MISC },
		{ 0x08, [fld_dev_stat17_4],MISC },
		{ 0x10, [fld_dev_stat17_5],MISC },
		{ 0x20, [fld_dev_stat17_6],MISC },
		{ 0x40, [fld_dev_stat17_7],MISC },
		{ 0x80, [fld_dev_stat17_8],MISC }
	}
}

VARIABLE xmtr_specific_status_9
{
	HELP [field_device_status_17_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_17];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat18_1],MISC },
		{ 0x02, [fld_dev_stat18_2],MISC },
		{ 0x04, [fld_dev_stat18_3],MISC },
		{ 0x08, [fld_dev_stat18_4],MISC },
		{ 0x10, [fld_dev_stat18_5],MISC },
		{ 0x20, [fld_dev_stat18_6],MISC },
		{ 0x40, [fld_dev_stat18_7],MISC },
		{ 0x80, [fld_dev_stat18_8],MISC }
	}
}

VARIABLE xmtr_specific_status_10
{
	HELP [field_device_status_18_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_18];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat19_1],MISC },
		{ 0x02, [fld_dev_stat19_2],MISC },
		{ 0x04, [fld_dev_stat19_3],MISC },
		{ 0x08, [fld_dev_stat19_4],MISC },
		{ 0x10, [fld_dev_stat19_5],MISC },
		{ 0x20, [fld_dev_stat19_6],MISC },
		{ 0x40, [fld_dev_stat19_7],MISC },
		{ 0x80, [fld_dev_stat19_8],MISC }
	}
}

VARIABLE xmtr_specific_status_11
{
	HELP [field_device_status_19_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_19];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat20_1],MISC },
		{ 0x02, [fld_dev_stat20_2],MISC },
		{ 0x04, [fld_dev_stat20_3],MISC },
		{ 0x08, [fld_dev_stat20_4],MISC },
		{ 0x10, [fld_dev_stat20_5],MISC },
		{ 0x20, [fld_dev_stat20_6],MISC },
		{ 0x40, [fld_dev_stat20_7],MISC },
		{ 0x80, [fld_dev_stat20_8],MISC }
	}
}

VARIABLE xmtr_specific_status_12
{
	HELP [field_device_status_20_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_20];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat21_1],MISC },
		{ 0x02, [fld_dev_stat21_2],MISC },
		{ 0x04, [fld_dev_stat21_3],MISC },
		{ 0x08, [fld_dev_stat21_4],MISC },
		{ 0x10, [fld_dev_stat21_5],MISC },
		{ 0x20, [fld_dev_stat21_6],MISC },
		{ 0x40, [fld_dev_stat21_7],MISC },
		{ 0x80, [fld_dev_stat21_8],MISC }
	}
}

VARIABLE xmtr_specific_status_13
{
	HELP [field_device_status_21_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_21];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat22_1],MISC },
		{ 0x02, [fld_dev_stat22_2],MISC },
		{ 0x04, [fld_dev_stat22_3],MISC },
		{ 0x08, [fld_dev_stat22_4],MISC },
		{ 0x10, [fld_dev_stat22_5],MISC },
		{ 0x20, [fld_dev_stat22_6],MISC },
		{ 0x40, [fld_dev_stat22_7],MISC },
		{ 0x80, [fld_dev_stat22_8],MISC }
	}
}

VARIABLE xmtr_specific_status_14
{
	HELP [field_device_status_22_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_22];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat23_1],MISC },
		{ 0x02, [fld_dev_stat23_2],MISC },
		{ 0x04, [fld_dev_stat23_3],MISC },
		{ 0x08, [fld_dev_stat23_4],MISC },
		{ 0x10, [fld_dev_stat23_5],MISC },
		{ 0x20, [fld_dev_stat23_6],MISC },
		{ 0x40, [fld_dev_stat23_7],MISC },
		{ 0x80, [fld_dev_stat23_8],MISC }
	}
}

VARIABLE xmtr_specific_status_15
{
	HELP [field_device_status_23_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_23];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat24_1],MISC },
		{ 0x02, [fld_dev_stat24_2],MISC },
		{ 0x04, [fld_dev_stat24_3],MISC },
		{ 0x08, [fld_dev_stat24_4],MISC },
		{ 0x10, [fld_dev_stat24_5],MISC },
		{ 0x20, [fld_dev_stat24_6],MISC },
		{ 0x40, [fld_dev_stat24_7],MISC },
		{ 0x80, [fld_dev_stat24_8],MISC }
	}
}

VARIABLE xmtr_specific_status_16
{
	HELP [field_device_status_24_help];
/*
	APPHELP "HART_VAR:XMTR SPEC STATUS"
		" These specific bits can be given attributes called 'Cause Status"
		" Classes'. See the Device Description Language Specification for the"
		" definitions of these 'Cause Status Classes'.";
*/
	LABEL [xmtr_specific_status_24];
	HANDLING READ;
	CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
	TYPE BIT_ENUMERATED
	{
		{ 0x01, [fld_dev_stat25_1],MISC },
		{ 0x02, [fld_dev_stat25_2],MISC },
		{ 0x04, [fld_dev_stat25_3],MISC },
		{ 0x08, [fld_dev_stat25_4],MISC },
		{ 0x10, [fld_dev_stat25_5],MISC },
		{ 0x20, [fld_dev_stat25_6],MISC },
		{ 0x40, [fld_dev_stat25_7],MISC },
		{ 0x80, [fld_dev_stat25_8],MISC }
	}
}

VARIABLE operating_mode_1
{
	HELP [operating_mode_1_help];
/*
	APPHELP "A mode affects the basic operation of the Field Device in some way,"
		" and is usually can be enabled or disabled. This variable does not"
		" indicate that the mode is in any state"
		" HART_VAR:OPER MODE #1";
*/
	LABEL [operating_mode_1];
	HANDLING READ;
	CLASS DIAGNOSTIC & DEVICE;
	TYPE ENUMERATED
	{
	  OPERATING_MODE_CODE(0)   /* Normal */
	}
}

VARIABLE operating_mode_2
{
	HELP [operating_mode_2_help];
/*
	APPHELP "A mode affects the basic operation of the Field Device in some way,"
		" and is usually can be enabled or disabled. This variable does not"
		" indicate that the mode is in any state"
		" HART_VAR:OPER MODE #2";
*/
	LABEL [operating_mode_2];
	HANDLING READ;
	CLASS DIAGNOSTIC & DEVICE;
	TYPE ENUMERATED
	{
	  OPERATING_MODE_CODE(0)   /* Normal */
	}
}

VARIABLE analog_output_saturated1
{
	HELP [analog_output_saturated_help];
/*
	APPHELP "NOTE- This is an extension of Bit #2 of the Field Device Status,
		" Second Byte."
		" HART_VAR:ANALOG OUTPUT SAT";
*/
	LABEL [analog_output_saturated];
	HANDLING READ;
	CLASS ANALOG_OUTPUT & DYNAMIC & DIAGNOSTIC;
	/* TYPE UNSIGNED_INTEGER (3); */  /* @ This is a bit encoded integer */
	TYPE BIT_ENUMERATED (1)
	{
		{0x01,[ao1_out_rnge_lim],MISC},
		{0x02,[ao2_out_rnge_lim],MISC},
		{0x04,[ao3_out_rnge_lim],MISC},
		{0x08,[ao4_out_rnge_lim],MISC},
		{0x10,[ao5_out_rnge_lim],MISC},
		{0x20,[ao6_out_rnge_lim],MISC},
		{0x40,[ao7_out_rnge_lim],MISC},
		{0x80,[ao8_out_rnge_lim],MISC}
	}
}

VARIABLE analog_output_saturated2
{
	HELP [analog_output_saturated_help];
/*
	APPHELP "NOTE- This is an extension of Bit #2 of the Field Device Status,
		" Second Byte."
		" HART_VAR:ANALOG OUTPUT SAT";
*/
	LABEL [analog_output_saturated];
	HANDLING READ;
	CLASS ANALOG_OUTPUT & DYNAMIC & DIAGNOSTIC;
	/* TYPE UNSIGNED_INTEGER (3); */  /* @ This is a bit encoded integer */
	TYPE BIT_ENUMERATED (1)
	{
		{0x01,[ao9_out_rnge_lim],MISC},
		{0x02,[ao10_out_rnge_lim],MISC},
		{0x04,[ao11_out_rnge_lim],MISC},
		{0x08,[ao12_out_rnge_lim],MISC},
		{0x10,[ao13_out_rnge_lim],MISC},
		{0x20,[ao14_out_rnge_lim],MISC},
		{0x40,[ao15_out_rnge_lim],MISC},
		{0x80,[ao16_out_rnge_lim],MISC}
	}
}

VARIABLE analog_output_saturated3
{
	HELP [analog_output_saturated_help];
/*
	APPHELP "NOTE- This is an extension of Bit #2 of the Field Device Status,
		" Second Byte."
		" HART_VAR:ANALOG OUTPUT SAT";
*/
	LABEL [analog_output_saturated];
	HANDLING READ;
	CLASS ANALOG_OUTPUT & DYNAMIC & DIAGNOSTIC;
	/* TYPE UNSIGNED_INTEGER (3); */  /* @ This is a bit encoded integer */
	TYPE BIT_ENUMERATED (1)
	{
		{0x01,[ao17_out_rnge_lim],MISC},
		{0x02,[ao18_out_rnge_lim],MISC},
		{0x04,[ao19_out_rnge_lim],MISC},
		{0x08,[ao20_out_rnge_lim],MISC},
		{0x10,[ao21_out_rnge_lim],MISC},
		{0x20,[ao22_out_rnge_lim],MISC},
		{0x40,[ao23_out_rnge_lim],MISC},
		{0x80,[ao24_out_rnge_lim],MISC}
	}
}

VARIABLE analog_output_fixed1
{
	HELP [analog_output_fixed_help];
/*
	APPHELP "NOTE- This is an extension of Bit #3 of the Field Device Status,
		" Second Byte."
		" HART_VAR:ANALOG OUTPUT FIXED";
*/
	LABEL [analog_output_fixed];
	HANDLING READ;
	CLASS ANALOG_OUTPUT & DYNAMIC & DIAGNOSTIC;
	/* TYPE UNSIGNED_INTEGER (3); */  /* @ This is a bit encoded integer */
	TYPE BIT_ENUMERATED (1)
	{
		{0x01,[ao1_in_fixed_mode],MISC},
		{0x02,[ao2_in_fixed_mode],MISC},
		{0x04,[ao3_in_fixed_mode],MISC},
		{0x08,[ao4_in_fixed_mode],MISC},
		{0x10,[ao5_in_fixed_mode],MISC},
		{0x20,[ao6_in_fixed_mode],MISC},
		{0x40,[ao7_in_fixed_mode],MISC},
		{0x80,[ao8_in_fixed_mode],MISC}
	}
}

VARIABLE analog_output_fixed2
{
	HELP [analog_output_fixed_help];
/*
	APPHELP "NOTE- This is an extension of Bit #3 of the Field Device Status,
		" Second Byte."
		" HART_VAR:ANALOG OUTPUT FIXED";
*/
	LABEL [analog_output_fixed];
	HANDLING READ;
	CLASS ANALOG_OUTPUT & DYNAMIC & DIAGNOSTIC;
	/* TYPE UNSIGNED_INTEGER (3); */  /* @ This is a bit encoded integer */
	TYPE BIT_ENUMERATED (1)
	{
		{0x01,[ao9_in_fixed_mode],MISC},
		{0x02,[ao10_in_fixed_mode],MISC},
		{0x04,[ao11_in_fixed_mode],MISC},
		{0x08,[ao12_in_fixed_mode],MISC},
		{0x10,[ao13_in_fixed_mode],MISC},
		{0x20,[ao14_in_fixed_mode],MISC},
		{0x40,[ao15_in_fixed_mode],MISC},
		{0x80,[ao16_in_fixed_mode],MISC}
	}
}

VARIABLE analog_output_fixed3
{
	HELP [analog_output_fixed_help];
/*
	APPHELP "NOTE- This is an extension of Bit #3 of the Field Device Status,
		" Second Byte."
		" HART_VAR:ANALOG OUTPUT FIXED";
*/
	LABEL [analog_output_fixed];
	HANDLING READ;
	CLASS ANALOG_OUTPUT & DYNAMIC & DIAGNOSTIC;
	/* TYPE UNSIGNED_INTEGER (3); */  /* @ This is a bit encoded integer */
	TYPE BIT_ENUMERATED (1)
	{
		{0x01,[ao17_in_fixed_mode],MISC},
		{0x02,[ao18_in_fixed_mode],MISC},
		{0x04,[ao19_in_fixed_mode],MISC},
		{0x08,[ao20_in_fixed_mode],MISC},
		{0x10,[ao21_in_fixed_mode],MISC},
		{0x20,[ao22_in_fixed_mode],MISC},
		{0x40,[ao23_in_fixed_mode],MISC},
		{0x80,[ao24_in_fixed_mode],MISC}
	}
}
#endif //XXXX

#ifdef XXXX //redefined
COMMAND read_additional_transmitter_status
{
	NUMBER 48;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
			response_code, device_status, xmtr_specific_status_0,
			xmtr_specific_status_1, xmtr_specific_status_2,
			xmtr_specific_status_3, xmtr_specific_status_4,
			xmtr_specific_status_5, operating_mode_1,
			operating_mode_2, analog_output_saturated1,
			analog_output_saturated2, analog_output_saturated3,
			analog_output_fixed1, analog_output_fixed2,
			analog_output_fixed3, xmtr_specific_status_6,
			xmtr_specific_status_7, xmtr_specific_status_8,
			xmtr_specific_status_9, xmtr_specific_status_10,
			xmtr_specific_status_11, xmtr_specific_status_12,
			xmtr_specific_status_13, xmtr_specific_status_14,
			xmtr_specific_status_15, xmtr_specific_status_16
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,		[no_command_specific_errors];
		6,	MISC_ERROR,	[xmtr_specific_command_error];
		8,	MISC_WARNING,	[update_in_progress];
		16,	MODE_ERROR,	[access_restricted];
	}
}
#endif //XXXX
COMMAND read_additional_transmitter_status
{
	NUMBER 48;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
					response_code, device_status,
					xmtr_specific_status_0,
					xmtr_specific_status_1
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,		[no_command_specific_errors];
		6,	MISC_ERROR,	[xmtr_specific_command_error];
		8,	MISC_WARNING,	[update_in_progress];
		16,	MODE_ERROR,	[access_restricted];
	}
}


#ifdef XXXX
COMMAND write_pv_sensor_serial_number
{
	NUMBER 49;

	OPERATION  WRITE;

	TRANSACTION
	{
		REQUEST
		{
			PV.SENSOR_SERIAL_NUMBER
		}

		REPLY
		{
			response_code, device_status, PV.SENSOR_SERIAL_NUMBER
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,	[no_command_specific_errors];
		5,	MISC_ERROR,	[too_few_data_bytes_recieved];
		6,	MISC_ERROR,	[xmtr_specific_command_error];
		7,	MODE_ERROR,	[in_write_protect_mode];
		16,	MODE_ERROR,	[access_restricted];
	}
}

VARIABLE primary_variable_code
{
	HELP [primary_variable_code_is_help];
/*
	APPHELP "The Primary Variable has other related variables. The Primary"
		" Variable is represented in an approximate analog format on Analog"
		" Output #1, if such an Analog Output exists."
		" HART_VAR:PV XMTR VAR CODE";
*/
	LABEL [primary_variable_is];
	CLASS HART;
	TYPE INDEX transmitter_variables;
	POST_EDIT_ACTIONS
	{
		warning_message
	}
}

VARIABLE secondary_variable_code
{
	HELP [secondary_variable_code_is_help];
/*
	APPHELP "The Secondary Variable has other related variables. The Secondary"
		" Variable is represented in an approximate analog format on Analog"
		" Output #2, if such an Analog Output exists."
		" HART_VAR:SV XMTR VAR CODE";
*/
	LABEL [secondary_variable_is];
	CLASS HART;
	TYPE INDEX transmitter_variables;
	POST_EDIT_ACTIONS
	{
		warning_message
	}
}

VARIABLE tertiary_variable_code
{
	HELP [tertiary_variable_code_is_help];
/*
	APPHELP "The Tertiary Variable has other related variables. The Tertiary"
		" Variable is represented in an approximate analog format on Analog"
		" Output #3, if such an Analog Output exists."
		" HART_VAR:TV XMTR VAR CODE";
*/
	LABEL [tertiary_variable_is];
	CLASS HART;
	TYPE INDEX transmitter_variables;
	POST_EDIT_ACTIONS
	{
		warning_message
	}
}

VARIABLE fourth_variable_code
{
	HELP [fourth_variable_code_is_help];
/*
	APPHELP "The Fourth Variable has other related variables. The Fourth"
		" Variable is represented in an approximate analog format on Analog"
		" Output #4, if such an Analog Output exists."
		" HART_VAR:4TH XMTR VAR CODE";
*/
	LABEL [fourth_variable_is];
	CLASS HART;
	TYPE INDEX transmitter_variables;
	POST_EDIT_ACTIONS
	{
		warning_message
	}
}

COMMAND read_transmitter_variable_assignments
{
	NUMBER 50;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
			response_code, device_status,
			primary_variable_code, secondary_variable_code,
			tertiary_variable_code, fourth_variable_code
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,	[no_command_specific_errors];
		6,	MISC_ERROR,	[xmtr_specific_command_error];
		16,	MODE_ERROR,	[access_restricted];
	}
}

COMMAND write_transmitter_variable_assignments
{
	NUMBER 51;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			primary_variable_code, secondary_variable_code,
			tertiary_variable_code, fourth_variable_code
		}

		REPLY
		{
			response_code, device_status,
			primary_variable_code, secondary_variable_code,
			tertiary_variable_code, fourth_variable_code
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		16,	MODE_ERROR,			[access_restricted];
	}
}

#endif //XXXX
VARIABLE transmitter_variable_code
{
	HELP [index_into_dynamic_variables_array_help];
/*
	APPHELP "This variable can represent measured or calculated type variables."
		" The numeric assigned to a Field Device variable can never be"
		" changed. If it is changed this would be a violation of the Forward"
		" Compatibility rules."
		" HART_VAR:XMTR VAR CODE";
*/
	TYPE INDEX transmitter_variables;
	CLASS USER_INTERFACE;

}

COMMAND set_transmitter_variable_zero
{
	NUMBER 52;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{
			transmitter_variable_code
		}

		REPLY
		{
			response_code, device_status, transmitter_variable_code
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		9,	PROCESS_ERROR,		[applied_process_too_high];
		10,	PROCESS_ERROR,		[applied_process_too_low];
		16,	MODE_ERROR,			[access_restricted];
	}
}

#ifdef XXXX
COMMAND write_transmitter_variable_units
{
	NUMBER 53;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			transmitter_variable_code (INFO,INDEX),
			transmitter_variables[transmitter_variable_code].DIGITAL_UNITS
		}

		REPLY
		{
			response_code, device_status, transmitter_variable_code (INFO,INDEX),
			transmitter_variables[transmitter_variable_code].DIGITAL_UNITS
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		11,	DATA_ENTRY_ERROR,	[invalid_transmitter_variable];
		12,	DATA_ENTRY_ERROR,	[invalid_units];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND read_transmitter_variable_information
{
	NUMBER 54;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{
			transmitter_variable_code (INFO,INDEX)
		}

		REPLY
		{
			response_code, device_status, transmitter_variable_code,
			transmitter_variables[transmitter_variable_code].SENSOR_SERIAL_NUMBER,
			transmitter_variables[transmitter_variable_code].SENSOR_UNITS,
			transmitter_variables[transmitter_variable_code].UPPER_SENSOR_LIMIT,
			transmitter_variables[transmitter_variable_code].LOWER_SENSOR_LIMIT,
			transmitter_variables[transmitter_variable_code].DAMPING_VALUE,
			transmitter_variables[transmitter_variable_code].MINIMUM_SPAN
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	MISC_ERROR,			[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND write_transmitter_variable_damping_value
{
	NUMBER 55;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			transmitter_variable_code (INFO,INDEX),
			transmitter_variables[transmitter_variable_code].DAMPING_VALUE
		}

		REPLY
		{
			response_code, device_status, transmitter_variable_code (INFO,INDEX),
			transmitter_variables[transmitter_variable_code].DAMPING_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		8,	DATA_ENTRY_WARNING,	[set_to_nearest_possible_value];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND write_transmitter_variable_sensor_serial_number
{
	NUMBER 56;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			transmitter_variable_code (INFO,INDEX),
			transmitter_variables[transmitter_variable_code].SENSOR_SERIAL_NUMBER
		}

		REPLY
		{
			response_code, device_status, transmitter_variable_code (INFO,INDEX),
			transmitter_variables[transmitter_variable_code].SENSOR_SERIAL_NUMBER
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		16,	MODE_ERROR,			[access_restricted];
	}
}

VARIABLE unit_tag
{
	HELP [unit_tag_help];
/*
	APPHELP "A Field Device may have sub applications that require being"
		" addressed individually. For this addressing the Tag variable"
		" associated with Command #11 should be used. This Tag is used to"
		" identify the application that controls the sub applications. This"
		" Text can be used by the user in any way. A recommended use is as"
		" a unique label to a plant that correlates to a Field Device label:"
		" a plant drawing, or on a Control System."
		" NOTE- HART does not recommend using this variable. If you have an"
		" application that controls the sub applications, all of these"
		" applications should be addressed using the HART Frame itself."
		" HART_VAR:UNIT TAG";
*/
	LABEL [unit_tag];
	CLASS DEVICE;
	TYPE PACKED_ASCII (8);
}

VARIABLE unit_descriptor
{
	HELP [unit_descriptor_help];
/*
	APPHELP "A Field Device may have sub applications that require being"
		" addressed individually. This Descriptor"
		" is used to identify the application that controls the sub"
		" applications. This text can be used by the user in any way. There is"
		" no recommended use.
		" NOTE- HART does not recommend using this variable. If you have an"
		" application that controls the sub applications, all of these"
		" applications should be addressed using the HART Frame itself."
		" HART_VAR:UNIT DESCR";
*/
	LABEL [unit_descriptor];
	CLASS DEVICE;
	TYPE PACKED_ASCII (16);
}

VARIABLE unit_date
{
	HELP [unit_date_help];
/*
	APPHELP "A Field Device may have sub applications that require being"
		" addressed individually. This Date is used to"
		" identify the application that controls the sub applications."
		" This text can be used by the user in any way. There is"
		" no recommended use.
		" Format: Byte Closest to the Delimiter: Day, Next Byte: Month,
		" Byte Furthest from the Delimiter: Year-1900.
		" NOTE- HART does not recommend using this variable. If you have an"
		" application that controls the sub applications, all of these"
		" applications should be addressed using the HART Frame itself."
		" HART_VAR:UNIT DATE";
*/
	LABEL [unit_date];
	CLASS DEVICE;
	TYPE DATE;
}

COMMAND read_unit_tag_descriptor_date
{
	NUMBER 57;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
			response_code, device_status,
			unit_tag, unit_descriptor, unit_date
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,	[no_command_specific_errors];
		6,	MISC_ERROR,	[xmtr_specific_command_error];
		16,	MODE_ERROR,	[access_restricted];
	}
}

COMMAND write_unit_tag_descriptor_date
{
	NUMBER 58;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			unit_tag, unit_descriptor, unit_date
		}

		REPLY
		{
			response_code, device_status,
			unit_tag, unit_descriptor, unit_date
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,	[no_command_specific_errors];
		5,	MISC_ERROR,	[too_few_data_bytes_recieved];
		6,	MISC_ERROR,	[xmtr_specific_command_error];
		7,	MODE_ERROR,	[in_write_protect_mode];
		16,	MODE_ERROR,	[access_restricted];
	}
}
#endif //XXXX

VARIABLE response_preambles
{
	HELP [number_of_response_preambles_help];
/*
	APPHELP "The valid range of values is dependant on the technology of"
		" the Hardware of the Physical Layer. The magnitude of this number"
		" includes the two preambles required by the Data Link Layer."
		" NOTE- This variable can affect the Data Link Layer"
		" HART_VAR:NUMBER RESP PREAM";
*/
	LABEL [number_of_response_preambles];
	CLASS HART;
	TYPE UNSIGNED_INTEGER;
	HANDLING WRITE;
}

COMMAND write_number_of_response_preambles
{
	NUMBER 59;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			response_preambles
		}

		REPLY
		{
			response_code, device_status, response_preambles
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		16,	MODE_ERROR,			[access_restricted];
	}
}

#ifdef XXXX
VARIABLE analog_output_code
{
	HELP [analog_output_number_help];
/*
	APPHELP "NOTE- Index = 0 is not valid"
		" NOTE- For Analog Output Number 1: Index = 1 ~= Primary Variable
		" NOTE- For Analog Output Number 2: Index = 2 ~= Secondary Variable
		" HART_VAR:ANALOG OUTPUT NUMBER CODE";
*/
	TYPE INDEX dynamic_variables;
	CLASS USER_INTERFACE & ANALOG_OUTPUT;
}

COMMAND read_analog_output_and_percent_of_range
{
	NUMBER 60;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{
			analog_output_code (INFO,INDEX)
		}

		REPLY
		{
			response_code, device_status, analog_output_code,
			dynamic_variables[analog_output_code].ANALOG_UNITS,
			dynamic_variables[analog_output_code].ANALOG_VALUE,
			dynamic_variables[analog_output_code].PERCENT_RANGE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	MISC_ERROR,			[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		8,	MISC_WARNING,		[update_failure];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND read_dynamic_variables_and_pv_analog_output
{
	NUMBER 61;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
			response_code, device_status,
			PV.ANALOG_UNITS, PV.ANALOG_VALUE,
			PV.DIGITAL_UNITS, PV.DIGITAL_VALUE,
			SV.DIGITAL_UNITS, SV.DIGITAL_VALUE,
			TV.DIGITAL_UNITS, TV.DIGITAL_VALUE,
			QV.DIGITAL_UNITS, QV.DIGITAL_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,		[no_command_specific_errors];
		6,	MISC_ERROR,		[xmtr_specific_command_error];
		8,	MISC_WARNING,	[update_failure];
		16,	MODE_ERROR,		[access_restricted];
	}
}

VARIABLE analog_output_code_1
{
	HELP [index_one_into_analog_output_array_help];
/*
	APPHELP "This variable is used to access more variables that relate to"
		" that Analog Output index."
		" NOTE- Index = 0 is not valid"
		" HART_VAR:SLOT #0 ANALOG OUTPUT NUMBER CODE";
*/
	TYPE INDEX dynamic_variables;
	CLASS USER_INTERFACE & ANALOG_OUTPUT;
}

VARIABLE analog_output_code_2
{
	HELP [index_two_into_analog_output_array_help];
/*
	APPHELP "This variable is used to access more variables that relate to"
		" that Analog Output index."
		" NOTE- Index = 0 is not valid"
		" HART_VAR:SLOT #1 ANALOG OUTPUT NUMBER CODE";
*/
	TYPE INDEX dynamic_variables;
	CLASS USER_INTERFACE & ANALOG_OUTPUT;
}

VARIABLE analog_output_code_3
{
	HELP [index_three_into_analog_output_array_help];
/*
	APPHELP "This variable is used to access more variables that relate to"
		" that Analog Output index."
		" NOTE- Index = 0 is not valid"
		" HART_VAR:SLOT #2 ANALOG OUTPUT NUMBER CODE";
*/
	TYPE INDEX dynamic_variables;
	CLASS USER_INTERFACE & ANALOG_OUTPUT;
}

VARIABLE analog_output_code_4
{
	HELP [index_four_into_analog_output_array_help];
/*
	APPHELP "This variable is used to access more variables that relate to"
		" that Analog Output index."
		" NOTE- Index = 0 is not valid"
		" HART_VAR:SLOT #3 ANALOG OUTPUT NUMBER CODE";
*/
	TYPE INDEX dynamic_variables;
	CLASS USER_INTERFACE & ANALOG_OUTPUT;
}

COMMAND read_analog_outputs
{
	NUMBER 62;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{
			analog_output_code_1(INFO,INDEX), analog_output_code_2(INFO,INDEX),
			analog_output_code_3(INFO,INDEX), analog_output_code_4(INFO,INDEX)
		}

		REPLY
		{
			response_code, device_status,
			analog_output_code_1,
			dynamic_variables[analog_output_code_1].ANALOG_UNITS,
			dynamic_variables[analog_output_code_1].ANALOG_VALUE,
			analog_output_code_2,
			dynamic_variables[analog_output_code_2].ANALOG_UNITS,
			dynamic_variables[analog_output_code_2].ANALOG_VALUE,
			analog_output_code_3,
			dynamic_variables[analog_output_code_3].ANALOG_UNITS,
			dynamic_variables[analog_output_code_3].ANALOG_VALUE,
			analog_output_code_4,
			dynamic_variables[analog_output_code_4].ANALOG_UNITS,
			dynamic_variables[analog_output_code_4].ANALOG_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	MISC_ERROR,			[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		8,	MISC_WARNING,		[update_failure];
	}
}

COMMAND read_analog_output_information
{
	NUMBER 63;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{
			analog_output_code (INFO,INDEX)
		}

		REPLY
		{
			response_code, device_status, analog_output_code,
			dynamic_variables[analog_output_code].ALARM_CODE,
			dynamic_variables[analog_output_code].TRANSFER_FUNCTION,
			dynamic_variables[analog_output_code].RANGE_UNITS,
			dynamic_variables[analog_output_code].UPPER_RANGE_VALUE,
			dynamic_variables[analog_output_code].LOWER_RANGE_VALUE,
			dynamic_variables[analog_output_code].ANALOG_DAMPING
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	MISC_ERROR,			[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,		[xmtr_specific_command_error];
		16,	MODE_ERROR,		[access_restricted];
	}
}

COMMAND write_analog_output_analog_damping_value
{
	NUMBER 64;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			analog_output_code (INFO,INDEX),
			dynamic_variables[analog_output_code].ANALOG_DAMPING
		}

		REPLY
		{
			response_code, device_status, analog_output_code (INFO,INDEX),
			dynamic_variables[analog_output_code].ANALOG_DAMPING
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,		[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		8,	DATA_ENTRY_WARNING,	[set_to_nearest_possible_value];
		16,	MODE_ERROR,		[access_restricted];
	}
}

COMMAND write_analog_output_range_values
{
	NUMBER 65;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			analog_output_code (INFO,INDEX),
			dynamic_variables[analog_output_code].RANGE_UNITS(INFO),
			dynamic_variables[analog_output_code].UPPER_RANGE_VALUE,
			dynamic_variables[analog_output_code].LOWER_RANGE_VALUE
		}

		REPLY
		{
			response_code, device_status, analog_output_code (INFO,INDEX),
			dynamic_variables[analog_output_code].RANGE_UNITS(INFO),
			dynamic_variables[analog_output_code].UPPER_RANGE_VALUE,
			dynamic_variables[analog_output_code].LOWER_RANGE_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,		[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		9,	DATA_ENTRY_ERROR,	[lower_range_value_too_high];
		10,	DATA_ENTRY_ERROR,	[lower_range_value_too_low];
		11,	DATA_ENTRY_ERROR,	[upper_range_value_too_high];
		12,	DATA_ENTRY_ERROR,	[upper_range_value_too_low];
		13,	DATA_ENTRY_ERROR,	[URV_and_LRV_out_of_limits];
		14,	DATA_ENTRY_ERROR,	[span_too_small];
		15,	DATA_ENTRY_ERROR,	[invalid_analog_output_number_code];
		16,	MODE_ERROR,			[access_restricted];
		28,	DATA_ENTRY_ERROR,	[invalid_units];
	}
}

COMMAND enter_exit_fixed_analog_output_mode
{
	NUMBER 66;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{
			analog_output_code (INFO,INDEX),
			dynamic_variables[analog_output_code].ANALOG_UNITS,
			dynamic_variables[analog_output_code].ANALOG_VALUE
		}

		REPLY
		{
			response_code, device_status, analog_output_code(INFO,INDEX),
			dynamic_variables[analog_output_code].ANALOG_UNITS,
			dynamic_variables[analog_output_code].ANALOG_VALUE
		}
	}

	RESPONSE_CODES
		{
			0,	SUCCESS,			[no_command_specific_errors];
			3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
			4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
			5,	MISC_ERROR,			[too_few_data_bytes_recieved];
			6,	MISC_ERROR,		[xmtr_specific_command_error];
			7,	MODE_ERROR,		[in_write_protect_mode];
			11,	MODE_ERROR,		[in_multidrop_mode];
			12,	DATA_ENTRY_ERROR,	[invalid_units];
			15,	DATA_ENTRY_ERROR,	[invalid_analog_output_number_code];
			16,	MODE_ERROR,		[access_restricted];
		}
}

COMMAND trim_analog_output_zero
{
	NUMBER 67;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{
			analog_output_code (INFO,INDEX),
			dynamic_variables[analog_output_code].ANALOG_UNITS,
			dynamic_variables[analog_output_code].ANALOG_VALUE
		}

		REPLY
		{
			response_code, device_status, analog_output_code,
			dynamic_variables[analog_output_code].ANALOG_UNITS,
			dynamic_variables[analog_output_code].ANALOG_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		9,	MODE_ERROR,			[not_in_proper_anlg_output_mode];
		11,	MODE_ERROR,			[in_multidrop_mode];
		12,	DATA_ENTRY_ERROR,	[invalid_units];
		15,	DATA_ENTRY_ERROR,	[invalid_analog_output_number_code];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND trim_analog_output_gain
{
	NUMBER 68;

	OPERATION COMMAND;

	TRANSACTION
	{
		REQUEST
		{
			analog_output_code (INFO,INDEX),
			dynamic_variables[analog_output_code].ANALOG_UNITS,
			dynamic_variables[analog_output_code].ANALOG_VALUE
		}

		REPLY
		{
			response_code, device_status, analog_output_code,
			dynamic_variables[analog_output_code].ANALOG_UNITS,
			dynamic_variables[analog_output_code].ANALOG_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,		[xmtr_specific_command_error];
		7,	MODE_ERROR,		[in_write_protect_mode];
		9,	MODE_ERROR,			[not_in_proper_anlg_output_mode];
		11,	MODE_ERROR,		[in_multidrop_mode];
		12,	DATA_ENTRY_ERROR,	[invalid_units];
		15,	DATA_ENTRY_ERROR,	[invalid_analog_output_number_code];
		16,	MODE_ERROR,		[access_restricted];
	}
}

COMMAND write_analog_output_transfer_function
{
	NUMBER 69;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			analog_output_code (INFO,INDEX),
			dynamic_variables[analog_output_code].TRANSFER_FUNCTION
		}

		REPLY
		{
			response_code, device_status, analog_output_code,
			dynamic_variables[analog_output_code].TRANSFER_FUNCTION
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,		[xmtr_specific_command_error];
		7,	MODE_ERROR,		[in_write_protect_mode];
		13,	DATA_ENTRY_ERROR,	[invalid_transfer_function_code];
		15,	DATA_ENTRY_ERROR,	[invalid_analog_output_number_code];
		16,	MODE_ERROR,		[access_restricted];
	}
}

COMMAND read_analog_output_endpoint_values
{
	NUMBER 70;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{
			analog_output_code (INFO,INDEX)
		}

		REPLY
		{
			response_code, device_status, analog_output_code,
			dynamic_variables[analog_output_code].ANALOG_UNITS,
			dynamic_variables[analog_output_code].UPPER_ENDPOINT_VALUE,
			dynamic_variables[analog_output_code].LOWER_ENDPOINT_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	MISC_ERROR,	[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,		[xmtr_specific_command_error];
		16,	MODE_ERROR,		[access_restricted];
	}
}

VARIABLE burst_variable_code_1
{
	HELP [index_into_dynamic_variables_array_1_help];
/*
	APPHELP "This is a handle, that is also an index assigned to a Field Device"
		" dynamic variable. It is used to access more variables that relate to"
		" that Field Device dynamic variable."
		" NOTE- This variable can affect the Data Link Layer"
		" HART_VAR:SLOT #0 XMTR VAR CODE";
*/
	CLASS HART;
	HANDLING WRITE;
	TYPE INDEX transmitter_variables;
}

VARIABLE burst_variable_code_2
{
	HELP [index_into_dynamic_variables_array_2_help];
/*
	APPHELP "This is a handle, that is also an index assigned to a Field Device"
		" dynamic variable. It is used to access more variables that relate to"
		" that Field Device dynamic variable."
		" NOTE- This variable can affect the Data Link Layer"
		" HART_VAR:SLOT #1 XMTR VAR CODE";
*/
	CLASS HART;
	HANDLING WRITE;
	TYPE INDEX transmitter_variables;
}

VARIABLE burst_variable_code_3
{
	HELP [index_into_dynamic_variables_array_3_help];
/*
	APPHELP "This is a handle, that is also an index assigned to a Field Device"
		" dynamic variable. It is used to access more variables that relate to"
		" that Field Device dynamic variable."
		" NOTE- This variable can affect the Data Link Layer"
		" HART_VAR:SLOT #2 XMTR VAR CODE";
*/
	CLASS HART;
	HANDLING WRITE;
	TYPE INDEX transmitter_variables;
}

VARIABLE burst_variable_code_4
{
	HELP [index_into_dynamic_variables_array_4_help];
/*
	APPHELP "This is a handle, that is also an index assigned to a Field Device"
		" dynamic variable. It is used to access more variables that relate to"
		" that Field Device dynamic variable."
		" NOTE- This variable can affect the Data Link Layer"
		" HART_VAR:SLOT #3 XMTR VAR CODE";
*/
	CLASS HART;
	HANDLING WRITE;
	TYPE INDEX transmitter_variables;
}

COMMAND write_burst_transmitter_variables
{
	NUMBER 107;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			burst_variable_code_1, burst_variable_code_2,
			burst_variable_code_3, burst_variable_code_4
		}

		REPLY
		{
			response_code, device_status,
			burst_variable_code_1, burst_variable_code_2,
			burst_variable_code_3, burst_variable_code_4
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		5,	MISC_ERROR,		[too_few_data_bytes_recieved];
		6,	MISC_ERROR,		[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		16,	MODE_ERROR,		[access_restricted];
	}
}

VARIABLE burst_command_number
{
	HELP [burst_command_number_help];
/*
	APPHELP "NOTE- This variable can affect the Data Link Layer"
		" NOTE- Field Devices must support HART Command #1, #2, & #3 if Burst
		" Mode can be enabled."
		" HART_VAR:BURST CMD NUMBER";
*/
	LABEL [burst_command_number];
	CLASS HART;
	TYPE ENUMERATED
	{
		{1, [primary_variable], [pv_help] },
		{2, [percent_range_and_current], [percent_rnge_help] },
		{3, [all_process_variables_and_current], [all_process_var_help] }
	}
	HANDLING WRITE;
}

COMMAND write_burst_command_number
{
	NUMBER 108;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			burst_command_number
		}

		REPLY
		{
			response_code, device_status, burst_command_number
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		16,	MODE_ERROR,			[access_restricted];
	}
}

VARIABLE burst_mode_select
{
	HELP [burst_mode_select_help];
/*
	APPHELP "NOTE- This variable can affect the Data Link Layer"
		" HART_VAR:BURST MODE SELECT CODE";
*/
	LABEL [burst_mode_select];
	CLASS HART;
	HANDLING WRITE;
	TYPE ENUMERATED
	{
	  BURST_MODE_CONTROL_CODE(0),  /* Off */
	  BURST_MODE_CONTROL_CODE(1),  /* On */
	  BURST_MODE_CONTROL_CODE(250), /* Not Used */
	  BURST_MODE_CONTROL_CODE(251), /* None */
	  BURST_MODE_CONTROL_CODE(252), /* Unknown */
	  BURST_MODE_CONTROL_CODE(253)  /* Special */
	}
}

COMMAND burst_mode_control
{
	NUMBER 109;

	OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
			burst_mode_select
		}

		REPLY
		{
			response_code, device_status, burst_mode_select
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
		2,	DATA_ENTRY_ERROR,	[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		7,	MODE_ERROR,			[in_write_protect_mode];
		16,	MODE_ERROR,			[access_restricted];
	}
}

COMMAND read_all_dynamic_variables
{
	NUMBER 110;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{}

		REPLY
		{
			response_code, device_status,
			PV.DIGITAL_UNITS, PV.DIGITAL_VALUE,
			SV.DIGITAL_UNITS, SV.DIGITAL_VALUE,
			TV.DIGITAL_UNITS, TV.DIGITAL_VALUE,
			QV.DIGITAL_UNITS, QV.DIGITAL_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,		[no_command_specific_errors];
		6,	MISC_ERROR,		[xmtr_specific_command_error];
		8,	MISC_WARNING,	[update_failure];
		16,	MODE_ERROR,		[access_restricted];
	}
}

/* default masks
	def_auto_retry_limit = 0;
	def_cmd_attempts = 1;
	def_ret_comm_abort_mask = TRUE;
	def_ret_comm_retry_mask = FALSE;
	def_ret_nodev_abort_mask = TRUE;
	def_ret_nodev_retry_mask = FALSE;
	def_comm_abort_mask = 0;
	def_comm_retry_mask = ALLBITS;
	def_status_abort_mask = DEVICE_MALFUNCTION;
	def_status_retry_mask = 0;
	def_resp_abort_mask = ACCESS_RESTRICTED | CMD_NOT_IMPLIMENTED;
	def_resp_retry_mask = 0;
	def_xmtr_ret_comm_abort_mask = TRUE;
	def_xmtr_ret_comm_retry_mask = FALSE;
	def_xmtr_ret_nodev_abort_mask = TRUE;
	def_xmtr_ret_nodev_retry_mask = FALSE;
	def_xmtr_comm_abort_mask = 0;
	def_xmtr_comm_retry_mask = ALLBITS;
	def_xmtr_status_abort_mask = DEVICE_MALFUNCTION;
	def_xmtr_status_retry_mask = 0;
	def_xmtr_resp_abort_mask = ACCESS_RESTRICTED | CMD_NOT_IMPLIMENTED;
	def_xmtr_resp_retry_mask = 0;
	def_xmtr_data_abort_mask = 0;
	def_xmtr_data_retry_mask = 0;
*/

METHOD loop_test
{
	LABEL [loop_test];

	HELP [loop_test_help];

	DEFINITION
	{
		char status[STATUS_SIZE];
		int choice;
		long var_id[1];
		int use_abort_method;
		char disp_string1[60];
		char disp_string2[60];
		int slen1;
		int slen2;

		slen1=60;
		slen2=60;
		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		add_abort_method(return_to_normal);

		IGNORE_ALL_RESPONSE_CODES();

		use_abort_method = 0;
		do {
			get_dictionary_string(choose_analog_output_level,disp_string1,slen1);
			get_dictionary_string(choices_4_20_other_end,disp_string2,slen2);
			choice = SELECT_FROM_LIST(disp_string1, disp_string2);
			switch ( choice ) {
			case 0:
				assign_float(PV.ANALOG_VALUE,4.0);
				break;

			case 1:
				assign_float(PV.ANALOG_VALUE,20.0);
				break;

			case 2:
				get_dictionary_string(loop_output,disp_string1,slen1);
				GET_DEV_VAR_VALUE(disp_string1, PV.ANALOG_VALUE);
				break;

			case 3:
			default:
				process_abort();
				break;
			}
			send(40,status);
			if (!use_abort_method) {
				if (( status[STATUS_RESPONSE_CODE] != 0)
						&& ( status[STATUS_RESPONSE_CODE] != 3)
						&& ( status[STATUS_RESPONSE_CODE] != 4)) {
					display_response_status(40,status[STATUS_RESPONSE_CODE]);
					get_dictionary_string(abort_last_error,disp_string1,slen1);
					DELAY(2,disp_string1);
					process_abort();
				}
				remove_abort_method(return_to_normal);
				add_abort_method(leave_fixed_current_mode);
				use_abort_method =1;
			}
			if ( status[STATUS_RESPONSE_CODE] ) {
				display_response_status(40,status[STATUS_RESPONSE_CODE]);
				if (( status[STATUS_RESPONSE_CODE] != 3)
						&& ( status[STATUS_RESPONSE_CODE] != 4)) {
					get_dictionary_string(abort_last_error,disp_string1,slen1);
					DELAY(2,disp_string1);
					process_abort();
				}
			}
			else {
				var_id[0] = VARID(PV.ANALOG_VALUE);
				get_dictionary_string(fld_dev_otpt_fixed,disp_string1,slen1);
				acknowledge(disp_string1,var_id);
			}
		} while ( choice < 3);
		process_abort();
	}
}
#endif //XXXX

#ifdef XXXX //redefined
METHOD dac_trim
{
	LABEL [DAC_trim];

	HELP [digital_to_analog_trim_help];

/*	APPHELP "This type of calibration is usually used to compensate for"
			      " drifting or aging output electronics";
*/
	DEFINITION
	{
		int retry;
		char status[STATUS_SIZE];
		long var_ids[2];
		char disp_string1[60];
		char disp_string2[60];
		int slen1;
		int slen2;

		slen1=60;
		slen2=60;

		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		add_abort_method(return_to_normal);

		IGNORE_ALL_DEVICE_STATUS();
		XMTR_IGNORE_ALL_DEVICE_STATUS();

		get_dictionary_string(connect_reference_meter,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);

		IGNORE_ALL_RESPONSE_CODES();

		get_dictionary_string(setting_fld_dev_4_ma,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		assign_float(PV.ANALOG_VALUE,4.0);
		send(40,status);

		if ( status[STATUS_RESPONSE_CODE] ) {
			display_response_status(40,status[STATUS_RESPONSE_CODE]);
			get_dictionary_string(abort_last_error,disp_string1,slen1);
			DELAY(2,disp_string1);
			process_abort();
		}

		remove_abort_method(return_to_normal);
		add_abort_method(leave_fixed_current_mode);

		var_ids[0] = VARID(PV.ANALOG_VALUE);

		do {
			get_dictionary_string(enter_meter_value,disp_string1,slen1);
			GET_DEV_VAR_VALUE(disp_string1, PV.ANALOG_VALUE);
			send(45,status);
			assign_float(PV.ANALOG_VALUE,4.0);
			if (( status[STATUS_RESPONSE_CODE] == 3 ) || ( status[STATUS_RESPONSE_CODE] == 4)) {
				display_response_status(45,status[STATUS_RESPONSE_CODE]);
				retry = 1;
			}
			else if ( status[STATUS_RESPONSE_CODE]) {
				display_response_status(45,status[STATUS_RESPONSE_CODE]);
				get_dictionary_string(abort_last_error,disp_string1,slen1);
				DELAY(2,disp_string1);
				process_abort();
			}
			else {
				get_dictionary_string(fld_dev_otpt_equal_ref_meter,disp_string1,slen1);
				get_dictionary_string(yes_no,disp_string2,slen2);
				retry=select_from_list(disp_string1,var_ids,disp_string2);
			}
		} while (retry);

		get_dictionary_string(setting_fld_dev_20_ma,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		assign_float(PV.ANALOG_VALUE,20.0);
		send(40,status);

		if ( status[STATUS_RESPONSE_CODE]) {
			display_response_status(40,status[STATUS_RESPONSE_CODE]);
			get_dictionary_string(abort_last_error,disp_string1,slen1);
			DELAY(2,disp_string1);
			process_abort();
		}

		do {
			get_dictionary_string(enter_meter_value,disp_string1,slen1);
			GET_DEV_VAR_VALUE(disp_string1, PV.ANALOG_VALUE);
			send(46,status);
			assign_float(PV.ANALOG_VALUE,20.0);

			if (( status[STATUS_RESPONSE_CODE] == 3 ) || ( status[STATUS_RESPONSE_CODE] == 4)) {
				display_response_status(46,status[STATUS_RESPONSE_CODE]);
				retry = 1;
			}
			else if ( status[STATUS_RESPONSE_CODE]) {
				display_response_status(46,status[STATUS_RESPONSE_CODE]);
				get_dictionary_string(abort_last_error,disp_string1,slen1);
				DELAY(2,disp_string1);
				process_abort();
			}
			else {
				get_dictionary_string(fld_dev_otpt_equal_ref_meter,disp_string1,slen1);
				get_dictionary_string(yes_no,disp_string2,slen2);
				retry=select_from_list(disp_string1,var_ids,disp_string2);
			}
		} while (retry);

		process_abort() ;
	}
}
#endif //XXXX
METHOD dac_trim
{
	LABEL [DAC_trim];

	HELP [digital_to_analog_trim_help];

	DEFINITION
	{
		int retry;
		char status[STATUS_SIZE];
		long var_ids[2];
		char disp_string1[60];
		char disp_string2[60];
		int slen1;
		int slen2;

		slen1=60;
		slen2=60;

		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		add_abort_method(return_to_normal);

		get_dictionary_string(connect_reference_meter,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);

		IGNORE_ALL_DEVICE_STATUS();
		IGNORE_ALL_RESPONSE_CODES();
		XMTR_IGNORE_ALL_DEVICE_STATUS();
		XMTR_IGNORE_ALL_RESPONSE_CODES();

		get_dictionary_string(setting_fld_dev_4_ma,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		assign_float(PV.ANALOG_VALUE,4.0);
		send(40,status);

		if (status[STATUS_RESPONSE_CODE]) {
			display_response_status(40,status[STATUS_RESPONSE_CODE]);
			get_dictionary_string(abort_last_error,disp_string1,slen1);
			DELAY(2,disp_string1);
			process_abort();
		}

		remove_abort_method(return_to_normal);
		add_abort_method(leave_fixed_current_mode);

		var_ids[0] = VARID(PV.ANALOG_VALUE);

		do {
			get_dictionary_string(enter_meter_value,disp_string1,slen1);
			GET_DEV_VAR_VALUE(disp_string1, PV.ANALOG_VALUE);
			send(45,status);
			assign_float(PV.ANALOG_VALUE,4.0);
			if ((status[STATUS_RESPONSE_CODE] == 3) || (status[STATUS_RESPONSE_CODE] == 4)) {
				display_response_status(45,status[STATUS_RESPONSE_CODE]);
				retry = 1;
			}
			else if (status[STATUS_RESPONSE_CODE]) {
				display_response_status(45,status[STATUS_RESPONSE_CODE]);
				get_dictionary_string(abort_last_error,disp_string1,slen1);
				DELAY(2,disp_string1);
				process_abort();
			}
			else {
				get_dictionary_string(fld_dev_otpt_equal_ref_meter,disp_string1,slen1);
				get_dictionary_string(yes_no,disp_string2,slen2);
				retry=select_from_list(disp_string1,var_ids,disp_string2);
			}
		} while (retry);

		get_dictionary_string(setting_fld_dev_20_ma,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		assign_float(PV.ANALOG_VALUE,20.0);
		send(40,status);

		if (status[STATUS_RESPONSE_CODE]) {
			display_response_status(40,status[STATUS_RESPONSE_CODE]);
			get_dictionary_string(abort_last_error,disp_string1,slen1);
			DELAY(2,disp_string1);
			process_abort();
		}

		do {
			get_dictionary_string(enter_meter_value,disp_string1,slen1);
			GET_DEV_VAR_VALUE(disp_string1, PV.ANALOG_VALUE);
			send(46,status);
			assign_float(PV.ANALOG_VALUE,20.0);

			if ((status[STATUS_RESPONSE_CODE] == 3) || (status[STATUS_RESPONSE_CODE] == 4)) {
				display_response_status(46,status[STATUS_RESPONSE_CODE]);
				retry = 1;
			}
			else if (status[STATUS_RESPONSE_CODE]) {
				display_response_status(46,status[STATUS_RESPONSE_CODE]);
				get_dictionary_string(abort_last_error,disp_string1,slen1);
				DELAY(2,disp_string1);
				process_abort();
			}
			else {
				get_dictionary_string(fld_dev_otpt_equal_ref_meter,disp_string1,slen1);
				get_dictionary_string(yes_no,disp_string2,slen2);
				retry=select_from_list(disp_string1,var_ids,disp_string2);
			}
		} while (retry);

		add_abort_method(burn_eeprom);	/* -change- */
		/* - - - - */
		process_abort();
	}
}

#ifdef XXXX
METHOD scaled_dac_trim
{
	LABEL [scaled_DAC_trim];

	HELP [digital_to_analog_scaled_trim_help];

/*  APPHELP "This type of calibration is usually used to compensate for"
	      " drifting or aging output electronics. A common usage of this is when the"
	      " reference is in different engineering units than the Analog Output"
	      " (Ex. reference meter is 0-100% when the Field Device output is in mA";
*/
	DEFINITION
	{
		int retry;
		char status[STATUS_SIZE];
		float low, high, tmp_av;
		char disp_string1[60];
		char disp_string2[60];
		int slen1;
		int slen2;

		slen1 =60;
		slen2 =60;

		IGNORE_ALL_DEVICE_STATUS();
		XMTR_IGNORE_ALL_DEVICE_STATUS();
		IGNORE_ALL_RESPONSE_CODES();

		low = 4.0;
		high = 20.0;

		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		add_abort_method(return_to_normal);

		do {
			get_dictionary_string(trim_scaled_from_low_to_high,disp_string1,slen1);
			get_dictionary_string(proceed_change,disp_string2,slen2);
			retry = SELECT_FROM_LIST(disp_string1,disp_string2);
			if (retry ) {
				do {
					get_dictionary_string(set_scale_lo_output_value,disp_string1,slen1);
					GET_LOCAL_VAR_VALUE(disp_string1, low);
					get_dictionary_string(set_scale_hi_output_value,disp_string1,slen1);
					GET_LOCAL_VAR_VALUE(disp_string1, high);
					if (!(high - low)) {
						get_dictionary_string(high_low_0_invalid,disp_string1,slen1);
						ACKNOWLEDGE(disp_string1);
					}
				} while (!(high - low));
			}
		} while (retry);

		get_dictionary_string(connect_reference_meter,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);

		get_dictionary_string(setting_fld_dev_4_ma,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		assign_float(PV.ANALOG_VALUE,4.0);
		send(40,status);
		if ( status[STATUS_RESPONSE_CODE] ) {
			display_response_status(40,status[STATUS_RESPONSE_CODE]);
			get_dictionary_string(abort_last_error,disp_string1,slen1);
			DELAY(2,disp_string1);
			process_abort();
		}

		remove_abort_method(return_to_normal);
		add_abort_method(leave_fixed_current_mode);

		do {
			assign_float(PV.ANALOG_VALUE, low);
			get_dictionary_string(enter_meter_value,disp_string1,slen1);
			GET_DEV_VAR_VALUE(disp_string1, PV.ANALOG_VALUE);
			tmp_av = fvar_value(PV.ANALOG_VALUE);
			assign_float(PV.ANALOG_VALUE, 16 / (high - low) * (tmp_av - low) + 4);
			send(45,status);
			if (( status[STATUS_RESPONSE_CODE] == 3 ) || ( status[STATUS_RESPONSE_CODE] == 4)) {
				display_response_status(45,status[STATUS_RESPONSE_CODE]);
				retry = 1;
			}
			else if ( status[STATUS_RESPONSE_CODE]) {
				display_response_status(45,status[STATUS_RESPONSE_CODE]);
				get_dictionary_string(abort_last_error,disp_string1,slen1);
				DELAY(2,disp_string1);
				process_abort();
			}
			else {
				get_dictionary_string(scaled_otpt_low_eq_dev,disp_string1,slen1);
				get_dictionary_string(yes_no,disp_string2,slen2);
				retry=SELECT_FROM_LIST(disp_string1,disp_string2);
			}
		} while (retry);

		get_dictionary_string(setting_fld_dev_20_ma,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		assign_float(PV.ANALOG_VALUE, 20.0);
		send(40,status);
		if ( status[STATUS_RESPONSE_CODE] ) {
			display_response_status(40,status[STATUS_RESPONSE_CODE]);
			get_dictionary_string(abort_last_error,disp_string1,slen1);
			DELAY(2,disp_string1);
			process_abort();
		}

		do {
			assign_float(PV.ANALOG_VALUE, high);
			get_dictionary_string(enter_meter_value,disp_string1,slen1);
			GET_DEV_VAR_VALUE(disp_string1, PV.ANALOG_VALUE);
			tmp_av = fvar_value(PV.ANALOG_VALUE);
			assign_float(PV.ANALOG_VALUE, 16 / (high - low) * (tmp_av - low) + 4);
			send(46,status);
			if (( status[STATUS_RESPONSE_CODE] == 3 ) || ( status[STATUS_RESPONSE_CODE] == 4)) {
				display_response_status(46,status[STATUS_RESPONSE_CODE]);
				retry = 1;
			}
			else if ( status[STATUS_RESPONSE_CODE]) {
				display_response_status(46,status[STATUS_RESPONSE_CODE]);
				get_dictionary_string(abort_last_error,disp_string1,slen1);
				DELAY(2,disp_string1);
				process_abort();
			}
			else {
				get_dictionary_string(scaled_otpt_high_eq_dev,disp_string1,slen1);
				get_dictionary_string(yes_no,disp_string2,slen2);
				retry=SELECT_FROM_LIST(disp_string1,disp_string2);
			}
		} while (retry);

		process_abort();
	}
}

METHOD zero_trim
{
	LABEL [zero_trim];

	HELP [zero_trim_help];

	DEFINITION
	{
		char status[STATUS_SIZE];
		int retry;
		char disp_string1[60];
		char disp_string2[60];
		int slen1;
		int slen2;

		slen1=60;
		slen2=60;

		IGNORE_ALL_RESPONSE_CODES();

		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		add_abort_method(return_to_normal);
		get_dictionary_string(this_will_affect_snsr_cal,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);

		do {
			get_dictionary_string(apply_0_input_to_snsr,disp_string1,slen1);
			ACKNOWLEDGE(disp_string1);

			get_dictionary_string(snsr_input_stabilizing,disp_string1,slen1);
			DELAY(3,disp_string1);

			send(43,status);

			if ( status[STATUS_RESPONSE_CODE] ) {
				display_response_status(43,status[STATUS_RESPONSE_CODE]);
				if ((status[STATUS_RESPONSE_CODE] != 9)
						&& ( status[STATUS_RESPONSE_CODE] != 10)) {
					get_dictionary_string(abort_last_error,disp_string1,slen1);
					DELAY(2,disp_string1);
					process_abort();
				}
				get_dictionary_string(zero_the_input_and_try_again,disp_string1,slen1);
				get_dictionary_string(yes_no,disp_string2,slen2);
				retry=SELECT_FROM_LIST(disp_string1,disp_string2);
			}
			else {
				get_dictionary_string(snsr_zero_succeeded,disp_string1,slen1);
				DELAY(3,disp_string1);
				process_abort();
			}
		} while ( !retry);
		process_abort();
	}
}
#endif //XXXX

METHOD leave_fixed_current_mode
{
	LABEL [leaving_fixed_current_mode];

	HELP [leaving_fixed_current_mode_help_2];

	DEFINITION
	{
		char status[STATUS_SIZE];
		long var_id[1];
		char disp_string1[60];
		int slen1;

		slen1 =60;

		assign_float(PV.ANALOG_VALUE,0.0);
		IGNORE_ALL_RESPONSE_CODES();
		do {
			get_dictionary_string(return_fld_dev_to_orig_otpt,disp_string1,slen1);
			DELAY(3,disp_string1);
			send(40,status);
			if ( status[STATUS_RESPONSE_CODE] ) {
				display_response_status(40,status[STATUS_RESPONSE_CODE]);
			}
		} while ( status[STATUS_RESPONSE_CODE]);
		get_dictionary_string(loop_may_be_returned_to_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
	}
}

#ifdef XXXX
METHOD applied_rerange
{
	LABEL [apply_values];

	HELP [applied_values_help];

	DEFINITION
	{
		int rc;
		long varid[3];
		char status[STATUS_SIZE];
		char disp_string1[60];
		char disp_string2[60];
		int slen1;
		int slen2;

		slen1 =60;
		slen2 =60;

		IGNORE_ALL_RESPONSE_CODES();

		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		add_abort_method(return_to_normal);

		varid[0] =VARID(PV.DIGITAL_VALUE);
		varid[1] =VARID(PV.DIGITAL_UNITS);
		while ( 1 ) {
			get_dictionary_string(set_the,disp_string1,slen1);
			get_dictionary_string(choice_4_20_exit,disp_string2,slen2);
			switch(SELECT_FROM_LIST(disp_string1,disp_string2)) {
			case 0:
				get_dictionary_string(apply_new_4ma_input,disp_string1,slen1);
				ACKNOWLEDGE(disp_string1);
				do {
					send_command(1);
					get_dictionary_string(current_applied_process_val,disp_string1,slen1);
					get_dictionary_string(set_4ma_read_new_leave,disp_string2,slen2);
					rc = select_from_list(disp_string1,varid,disp_string2);
				} while(rc==1);
				if( rc == 0 ) {
					send(37,status);
					if ( status[STATUS_RESPONSE_CODE] ) {
						display_response_status(37,status[STATUS_RESPONSE_CODE]);
					}
					send_command(15);
				}
				break;
			case 1:
				get_dictionary_string(apply_new_20ma_input,disp_string1,slen1);
				ACKNOWLEDGE(disp_string1);
				do {
					send_command(1);
					get_dictionary_string(current_applied_process_val,disp_string1,slen1);
					get_dictionary_string(set_20ma_read_new_leave,disp_string2,slen2);
					rc = select_from_list(disp_string1,varid,disp_string2);
				} while(rc==1);
				if( rc == 0 ) {
					send(36,status);
					if ( status[STATUS_RESPONSE_CODE] ) {
						display_response_status(36,status[STATUS_RESPONSE_CODE]);
					}
					send_command(15);
				}
				break;
			case 2:
				process_abort();
			default:
				process_abort();
			}
		}
	}
}
#endif //XXXX

METHOD return_to_normal
{
	LABEL [aborting_return_to_normal];
	DEFINITION
	{
		char disp_string1[60];
		int slen1;

		slen1 =60;
		get_dictionary_string(loop_may_be_returned_to_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
	}
}

#ifdef XXXX
METHOD warning_message
{
	LABEL [set_loop_to_manual];
	DEFINITION
	{
		char disp_string1[126];
		int slen1;

		slen1 =125;
		get_dictionary_string(remove_from_auto_befor_send,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
	}
}

METHOD fixed_analog_output
{
	LABEL [fix_analog_output];

	HELP [fix_analog_output_help];

	DEFINITION
	{
		char status[STATUS_SIZE];
		int choice;
		long var_id[3];
		int use_abort_method;
		char disp_string1[60];
		char disp_string2[60];
		int slen1;
		int slen2;

		slen1 =60;
		slen2 =60;

		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		add_abort_method(return_to_normal);

		IGNORE_ALL_RESPONSE_CODES();

		use_abort_method = 0;

		get_dictionary_string(select_analog_output_to_trim,disp_string1,slen1);
		GET_DEV_VAR_VALUE(disp_string1,analog_output_code);
		get_dictionary_string(select_analog_output_units,disp_string1,slen1);
		GET_DEV_VAR_VALUE(disp_string1,
				dynamic_variables[ivar_value(analog_output_code)].ANALOG_UNITS);
		var_id[0] = VARID(analog_output_code);
		var_id[2] = VARID(dynamic_variables[ivar_value(analog_output_code)].ANALOG_UNITS);
		do {
			if (ivar_value(dynamic_variables[ivar_value(analog_output_code)].ANALOG_UNITS)== 39) {
				get_dictionary_string(choose_analog_output_level,disp_string1,slen1);
				get_dictionary_string(choices_4_20_other_end,disp_string2,slen2);
				choice = SELECT_FROM_LIST(disp_string1, disp_string2);
				switch ( choice ) {
				case 0:
					assign_float(dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE,4.0);
					break;

				case 1:
					assign_float(dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE,20.0);
					break;

				case 2:
					get_dictionary_string(enter_desired_analog_output,disp_string1,slen1);
					GET_DEV_VAR_VALUE(disp_string1,
							dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE);
					break;

				case 3:
				default:
					process_abort();
					break;
				}
			}
			else {
				get_dictionary_string(choose_analog_output_level,disp_string1,slen1);
				get_dictionary_string(new_value_end,disp_string2,slen2);
				choice = SELECT_FROM_LIST(disp_string1,disp_string2);
				switch(choice) {
				case 0:
					get_dictionary_string(enter_desired_analog_output,disp_string1,slen1);
					GET_DEV_VAR_VALUE(disp_string1,
							dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE);
					break;
				case 1:
					process_abort();
					break;
				}
			}

			send(66,status);
			if ( !use_abort_method ) {
				if (( status[STATUS_RESPONSE_CODE] != 0)
						&& ( status[STATUS_RESPONSE_CODE] != 3)
						&& ( status[STATUS_RESPONSE_CODE] != 4)) {
					display_response_status(66,status[STATUS_RESPONSE_CODE]);
					get_dictionary_string(abort_last_error,disp_string1,slen1);
					DELAY(2,disp_string1);
					process_abort();
				}
				use_abort_method = 1;
				remove_abort_method(return_to_normal);
				add_abort_method(leave_analog_fixed_current_mode);
			}
			if ( status[STATUS_RESPONSE_CODE] ) {
				display_response_status(66,status[STATUS_RESPONSE_CODE]);
				if (( status[STATUS_RESPONSE_CODE] != 3)
						&& ( status[STATUS_RESPONSE_CODE] != 4)) {
					get_dictionary_string(abort_last_error,disp_string1,slen1);
					DELAY(2,disp_string1);
					process_abort();
				}
			}
			else {
				var_id[1]=VARID(dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE);
				get_dictionary_string(fld_dev_AO_is_fixed_at,disp_string1,slen1);
				acknowledge(disp_string1,var_id);
			}
		} while ( choice < 3);
	}
}

METHOD analog_dac_trim
{
	LABEL [trim_analog_output];

	HELP [digital_to_analog_trim_help];

/*	APPHELP "This type of calibration is usually used to compensate for"
			      " drifting or aging output electronics";
*/
	DEFINITION
	{
		char status[STATUS_SIZE];
		long var_id[3];
		int retry;
		char disp_string1[60];
		char disp_string2[60];
		int slen1;
		int slen2;

		slen1 =60;
		slen2 =60;

		IGNORE_ALL_RESPONSE_CODES();

		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		add_abort_method(return_to_normal);
		get_dictionary_string(connect_reference_meter,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);

		get_dictionary_string(select_analog_output_to_trim,disp_string1,slen1);
		GET_DEV_VAR_VALUE(disp_string1,analog_output_code);
		get_dictionary_string(select_analog_output_units,disp_string1,slen1);
		GET_DEV_VAR_VALUE(disp_string1,
				dynamic_variables[ivar_value(analog_output_code)].ANALOG_UNITS);

		var_id[0] = VARID(dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE);
		var_id[1] = VARID(dynamic_variables[ivar_value(analog_output_code)].ANALOG_UNITS);

		assign_var(dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE,
				dynamic_variables[ivar_value(analog_output_code)].LOWER_ENDPOINT_VALUE);

		get_dictionary_string(about_to_set_fld_dev_output,disp_string1,slen1);
		acknowledge(disp_string1,var_id);
		send(66,status);

		if (status[STATUS_RESPONSE_CODE]) {
			display_response_status(66,status[STATUS_RESPONSE_CODE]);
			get_dictionary_string(abort_last_error,disp_string1,slen1);
			DELAY(2,disp_string1);
			process_abort();
		}
		else {
			remove_abort_method(return_to_normal);
			add_abort_method(leave_analog_fixed_current_mode);
		}

		do {
			assign_var(dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE,
					dynamic_variables[ivar_value(analog_output_code)].LOWER_ENDPOINT_VALUE);
			get_dictionary_string(enter_meter_value,disp_string1,slen1);
			GET_DEV_VAR_VALUE(disp_string1,
					dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE);
			send(67,status);

			if (( status[STATUS_RESPONSE_CODE] == 3 ) || ( status[STATUS_RESPONSE_CODE] == 4)) {
				display_response_status(67,status[STATUS_RESPONSE_CODE]);
				retry = 1;
			}
			else if ( status[STATUS_RESPONSE_CODE]) {
				display_response_status(67,status[STATUS_RESPONSE_CODE]);
				get_dictionary_string(abort_last_error,disp_string1,slen1);
				DELAY(2,disp_string1);
				process_abort();
			}
			else {
				get_dictionary_string(fld_dev_output_eq_ref_meter,disp_string1,slen1);
				get_dictionary_string(yes_no,disp_string2,slen2);
				retry=select_from_list(disp_string1,var_id,disp_string2);
			}
		} while (retry);

		assign_var(dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE,
				dynamic_variables[ivar_value(analog_output_code)].UPPER_ENDPOINT_VALUE);

		get_dictionary_string(about_to_set_fld_dev_output,disp_string1,slen1);
		acknowledge(disp_string1,var_id);
		send(66, status);

		if (status[STATUS_RESPONSE_CODE]) {
			display_response_status(66,status[STATUS_RESPONSE_CODE]);
			get_dictionary_string(abort_last_error,disp_string1,slen1);
			DELAY(2,disp_string1);
			process_abort();
		}

		do {
			assign_var(dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE,
					dynamic_variables[ivar_value(analog_output_code)].UPPER_ENDPOINT_VALUE);
			get_dictionary_string(enter_meter_value,disp_string1,slen1);
			GET_DEV_VAR_VALUE(disp_string1,
					dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE);

			send(68,status);
			if (( status[STATUS_RESPONSE_CODE] == 3 ) || ( status[STATUS_RESPONSE_CODE] == 4)) {
				display_response_status(68,status[STATUS_RESPONSE_CODE]);
				retry = 1;
			}
			else if (status[STATUS_RESPONSE_CODE]) {
				display_response_status(68,status[STATUS_RESPONSE_CODE]);
				get_dictionary_string(abort_last_error,disp_string1,slen1);
				DELAY(2,disp_string1);
				process_abort();
			}
			else {
				get_dictionary_string(fld_dev_output_eq_ref_meter,disp_string1,slen1);
				get_dictionary_string(yes_no,disp_string2,slen2);
				retry=select_from_list(disp_string1,var_id,disp_string2);
			}
		} while (retry);
		process_abort();
	}
}

METHOD tv_zero_trim
{
	LABEL [field_device_variable_zero_trim];

	HELP [zero_trim_help];

	DEFINITION
	{
		char status[STATUS_SIZE];
		int tv;
		int retry;
		char disp_string1[60];
		char disp_string2[60];
		int slen1;
		int slen2;

		slen1=60;
		slen2=60;

		IGNORE_ALL_RESPONSE_CODES();

		get_dictionary_string(remove_loop_from_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
		add_abort_method(return_to_normal);
		get_dictionary_string(this_will_affect_snsr_cal,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);

		get_dictionary_string(select_fld_dev_var_snsr_trim,disp_string1,slen1);
		GET_DEV_VAR_VALUE(disp_string1,transmitter_variable_code);

		do {
			get_dictionary_string(apply_0_input_to_snsr,disp_string1,slen1);
			ACKNOWLEDGE(disp_string1);

			get_dictionary_string(snsr_input_stabilizing,disp_string1,slen1);
			DELAY(3,disp_string1);

			send(52,status);

			if ( status[STATUS_RESPONSE_CODE] ) {
				display_response_status(52,status[STATUS_RESPONSE_CODE]);
				if ((status[STATUS_RESPONSE_CODE] != 2)
						&& ( status[STATUS_RESPONSE_CODE] != 9)
						&& ( status[STATUS_RESPONSE_CODE] != 10)) {
					get_dictionary_string(abort_last_error,disp_string1,slen1);
					DELAY(2,disp_string1);
					process_abort();
				}
				get_dictionary_string(zero_the_input_and_try_again,disp_string1,slen1);
				get_dictionary_string(yes_no,disp_string2,slen2);
				retry=SELECT_FROM_LIST(disp_string1,disp_string2);
				if ( !retry) {
					if ( status[STATUS_RESPONSE_CODE] == 2 ) {
						do {
							tv = ivar_value(transmitter_variable_code);
							get_dictionary_string(select_fld_dev_var_snsr_trim,disp_string1,slen1);
							GET_DEV_VAR_VALUE(disp_string1,transmitter_variable_code);
							if (tv == ivar_value(transmitter_variable_code)) {
								get_dictionary_string(invalid_value_try_again,disp_string1,slen1);
								DELAY(2,disp_string1);
							}
						} while (tv == ivar_value(transmitter_variable_code));
					}
				}
			}
			else {
				get_dictionary_string(snsr_zero_succeeded,disp_string1,slen1);
				DELAY(3,disp_string1);
				process_abort();
			}
		} while ( !retry);
		process_abort();
	}
}

METHOD leave_analog_fixed_current_mode
{
	LABEL [leaving_fixed_current_mode];

	HELP [leaving_fixed_current_mode_help_1];

	DEFINITION
	{
		char status[STATUS_SIZE];
		long var_id[1];
		char disp_string1[60];
		int slen1;

		slen1 =60;

		assign_float(dynamic_variables[ivar_value(analog_output_code)].ANALOG_VALUE,NaN);
		IGNORE_ALL_RESPONSE_CODES();
		do {
			get_dictionary_string(return_fld_dev_to_orig_otpt,disp_string1,slen1);
			DELAY(3,disp_string1);
			send(66,status);
			if ( status[STATUS_RESPONSE_CODE] ) {
				display_response_status(66,status[STATUS_RESPONSE_CODE]);
			}
		} while( status[STATUS_RESPONSE_CODE] );
		get_dictionary_string(loop_may_be_returned_to_auto,disp_string1,slen1);
		ACKNOWLEDGE(disp_string1);
	}
}
#endif //XXXX

#ifdef XXXX //redefined
METHOD burn_eeprom
{
	LABEL [burn_eeprom];

	HELP [burn_eeprom_help];

	DEFINITION
	{
		char status[3];
		char disp_string1[60];
		int slen1;

		slen1 =60;

		IGNORE_ALL_DEVICE_STATUS();
		XMTR_IGNORE_ALL_DEVICE_STATUS();

		assign_int(eeprom_select,0);
		get_dictionary_string(making_changes_permanent,disp_string1,slen1);
		DELAY(3,disp_string1);
		send(39,status);
		if ( status[STATUS_RESPONSE_CODE] ) {
			   display_response_status(39,status[STATUS_RESPONSE_CODE]);
				get_dictionary_string(previous_err_seen_brn_eeprom,disp_string1,slen1);
			   ACKNOWLEDGE(disp_string1);
		}
	}
}
#endif //XXXX
METHOD burn_eeprom
{
	LABEL [burn_eeprom];

	HELP [burn_eeprom_help];

	DEFINITION
	{
		char status[3];
		char disp_string1[60];
		int slen1;

		slen1 =60;

		IGNORE_ALL_RESPONSE_CODES();
		XMTR_IGNORE_ALL_RESPONSE_CODES();
		IGNORE_ALL_DEVICE_STATUS();
		XMTR_IGNORE_ALL_DEVICE_STATUS();
		RETRY_ON_RESPONSE_CODE(DEVICE_BUSY);/* -change- */
		SET_NUMBER_OF_RETRIES(10);					/* - - - - */

		assign_int(eeprom_select,0);
		get_dictionary_string(making_changes_permanent,disp_string1,slen1);
		DELAY(3,disp_string1);
		send(39,status);
		if (status[STATUS_RESPONSE_CODE]) {
			display_response_status(39,status[STATUS_RESPONSE_CODE]);
			get_dictionary_string(previous_err_seen_brn_eeprom,disp_string1,slen1);
			ACKNOWLEDGE(disp_string1);
		}
	}
}

