/*
 * standard menu Device Description
 *
 * @(#)menu.ddl	9.1 6/14/93
 */

//XXXX#include "bi_codes.h"
//XXXX#include "macros.ddl"

//XXXXMANUFACTURER STANDARD, DEVICE_TYPE _MENU, DEVICE_REVISION 1, DD_REVISION 1

/*
 *	  Menus
 */
#ifdef XXXX

MENU device_setup
{
		LABEL [device_setup];
		ITEMS
		{
//		process_variables,				/* menu */
		diag_service,					/* menu */
		basic_setup,					/* menu */
Tab_input,
Tab_outputs,
//		detailed_setup,					/* menu */
		review (REVIEW)					/* menu */
		}
}

MENU process_variables
{
	LABEL [process_variables];
	ITEMS
	{
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
		/* Multiparameter instruments may wish to use directories
		to group their variables. This example is for a single
		parameter instrument.

		DO NOT USE PV REFERENCES HERE. INSTEAD USE COLLECTION
		REFERENCES. What we want to display are the transmitter
		variables, not which is attached to PV */

		process_pressure.DIGITAL_VALUE (DISPLAY_VALUE),	/* variable */
		process_pressure.PERCENT_RANGE (DISPLAY_VALUE),	/* variable */
		analog_output_value (DISPLAY_VALUE, READ_ONLY)	/* variable */
#else
		dummy_menu_entry
#endif
		/* Your extra variables here. */
	}
}

MENU diag_service
{
	LABEL [diagnostics_and_service];
	ITEMS
	{
		test_device,	/* menu */
		loop_test,		/* common-method */
		calibration,
		dac_trim		/* common-method  (OPTIONAL) */
	}
}


MENU test_device
{
		LABEL [test_device];
		ITEMS
		{
			status_display,
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
			/* Put whatever you selftest method is here */
			self_test
#else
		dummy_menu_entry
#endif
		}
}

MENU calibration
{
		LABEL [calibration];
		ITEMS
		{
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
			/* This is really rerange but we call it
			   calibration because of common venacular. */
			applied_rerange,		/* Method */
			key_pad_rerange 		/* Edit display */
#else
		dummy_menu_entry
#endif
		}
}

MENU status_display
{
		LABEL [status];
		ITEMS
		{
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
			/* Put your status bytes returned in command 48 here */
			xmtr_specific_status_0 (DISPLAY_VALUE),		/* var */
			xmtr_specific_status_1 (DISPLAY_VALUE)		/* var */
#else
		dummy_menu_entry
#endif
		}
}

MENU basic_setup
{
	LABEL  "basic setup""|de|Grundeinstellung";
	ITEMS
	{
//		device_info,
//		process_data_menu
flow_damping_value (DISPLAY_VALUE),
	}
}
//MENU process_data_menu
//{
//	LABEL  "basic setup""|de|Grundeinstellung";
//	ITEMS
//	{
//		sensor_range_menu,
//		Tab_s_input_measwindow,
//		flow_damping_value (DISPLAY_VALUE),
//		flow_units (DISPLAY_VALUE),
//		transfer_function (DISPLAY_VALUE),
		//totl_units (DISPLAY_VALUE)
//	}
//}

MENU sensor_range_menu
{
	LABEL  "Sensor range""|de|Sensorgrenzwerte";
	ITEMS
	{
		flow_upper_sensor_limit (DISPLAY_VALUE),
		flow_lower_sensor_limit (DISPLAY_VALUE)
	}
}



//MENU detailed_setup
//{
//	LABEL [detailed_setup];
//	ITEMS
//	{
//		totalizer_switch	(DISPLAY_VALUE),
//		volume_flow_cutoff(DISPLAY_VALUE),
//		mnu_NAMUR,
//		reset_totalizer_method
//	}
//}

MENU device_info
{
	LABEL [device_information];
	ITEMS
	{
		/* Put all methods and variables labeled as DDL
		CLASS DEVICE_INFO in this menu */
		manufacturer_id,
		device_type (DISPLAY_VALUE),
		device_id (DISPLAY_VALUE),
		tag (DISPLAY_VALUE),
		date (DISPLAY_VALUE),
		write_protect (DISPLAY_VALUE),
		descriptor,
		message,
		final_assembly_number,
		device_revisions,
		construction_materials				/* Menu */
		}
}


MENU device_revisions
{
	LABEL [revision_numbers];
	ITEMS
	{
		universal_revision (DISPLAY_VALUE),
		transmitter_revision (DISPLAY_VALUE),
		software_revision (DISPLAY_VALUE)
	}
}





MENU output_conditioning
{
	LABEL [output_condition];
	ITEMS
	{
	/* Under this menu should be all variables of DDL
		CLASS HART, ANALOG_OUTPUT,FREQUENCY,DISCRETE */
		analog_output,				/* Menu	*/
		hart_output,				/* Menu	*/
		frequency_output,			/* Menu	 OPTIONAL	*/
		discrete_output				/* Menu	 OPTIONAL	*/
	}
}

MENU analog_output
{
		LABEL [analog_output];
		ITEMS
		{
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
			analog_output_value (DISPLAY_VALUE,READ_ONLY),	/* variable */
			analog_output_alarm_select (DISPLAY_VALUE),
			loop_test,									  	/* method */
			dac_trim									   	/* method */
#else
		dummy_menu_entry
#endif
		}
}

MENU hart_output
{
		LABEL [HART_output];
		ITEMS
		{
			polling_address (DISPLAY_VALUE),		/* Variable	*/
			request_preambles (DISPLAY_VALUE),		/* Variable	*/
			burst_mode_select (DISPLAY_VALUE),		/* variable */
			burst_command_number (DISPLAY_VALUE)	/* variable */
		}
}


MENU discrete_output
{
		LABEL [discrete_output];
		ITEMS
		{
			dummy_menu_entry
		}
}

MENU review
{
	LABEL [review];
	ITEMS
	{
	/* List all variable accessable to the user in this menu */
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
		device_type (DISPLAY_VALUE, READ_ONLY),             /* var */
		private_label_distributor (DISPLAY_VALUE, READ_ONLY), /* var */
		meter_installation (DISPLAY_VALUE, READ_ONLY),		/* var */
		write_protect (DISPLAY_VALUE, READ_ONLY),			/* var */
		manufacturer_id (DISPLAY_VALUE, READ_ONLY),			/* var */
		device_id (DISPLAY_VALUE, READ_ONLY),				/* var */
		tag (DISPLAY_VALUE, READ_ONLY), 					/* var */
		descriptor (DISPLAY_VALUE, READ_ONLY),				/* var */
		message (DISPLAY_VALUE, READ_ONLY),					/* var */
		date (DISPLAY_VALUE, READ_ONLY),					/* var */
		final_assembly_number (DISPLAY_VALUE),				/* var */
		universal_revision (DISPLAY_VALUE, READ_ONLY),		/* var */
		transmitter_revision (DISPLAY_VALUE, READ_ONLY),	/* var */
		software_revision (DISPLAY_VALUE, READ_ONLY),		/* var */
		burst_mode_select (DISPLAY_VALUE, READ_ONLY),		/* var */
		burst_command_number (DISPLAY_VALUE, READ_ONLY),	/* var */
		polling_address (DISPLAY_VALUE, READ_ONLY),			/* var */
		request_preambles (DISPLAY_VALUE, READ_ONLY)		/* var */
#else
		dummy_menu_entry
#endif
	}
}
#endif //XXXX

MENU hot_key
{
	LABEL [hot_key];
	ITEMS
	{
		rerange 				/* edit_display */
	}
}

WRITE_AS_ONE range_wao
{
	PV.LOWER_RANGE_VALUE,		/* variable */
	PV.UPPER_RANGE_VALUE		/* variable */
}

EDIT_DISPLAY rerange
{
  LABEL [range_values];

  EDIT_ITEMS { range_wao, PV.DIGITAL_UNITS }

  DISPLAY_ITEMS {
				PV.LOWER_SENSOR_LIMIT,
				PV.UPPER_SENSOR_LIMIT
				}
}

/* Simply a place holder so I can compile */
VARIABLE dummy_menu_entry
   {
   LABEL [not_applicable];
   HANDLING READ;
   TYPE ENUMERATED
      {
         {0, [not_applicable] }
      }
}

