/*
 * HART Universal Commands
 *
 *		@(#)univ5.ddl	9.1	6/14/93
 */

//XXXX#include "macros.ddl"

//XXXXMANUFACTURER STANDARD, DEVICE_TYPE _UNIVERSAL, DEVICE_REVISION 5, DD_REVISION 1
/* This file conforms to the document:
 *    HART Smart Communications Protocol - Universal Command Specification,
 *    Revision 5.1
 * This file conforms to the document:
 *    HART Smart Communications Protocol - Common Tables,
 *    Revision 6.0
 * This file conforms to the document:
 *    HART Smart Communications Protocol - Command Summary Information,
 *    Revision 7.0
 */

/*
 * The manufacturer codes are defined here as a macro because they values are
 * needed for two distinct variables: manufacturer_id and private_label_distributor.
 */

#define MANUFACTURER_CODES \
    COMPANY_IDENTIFICATION_CODE(1), \
    COMPANY_IDENTIFICATION_CODE(2), \
    COMPANY_IDENTIFICATION_CODE(3), \
    COMPANY_IDENTIFICATION_CODE(4), \
    COMPANY_IDENTIFICATION_CODE(5), \
    COMPANY_IDENTIFICATION_CODE(6), \
    COMPANY_IDENTIFICATION_CODE (7), \
    COMPANY_IDENTIFICATION_CODE (8), \
    COMPANY_IDENTIFICATION_CODE (9), \
    COMPANY_IDENTIFICATION_CODE (10), \
    COMPANY_IDENTIFICATION_CODE (11), \
    COMPANY_IDENTIFICATION_CODE (12), \
    COMPANY_IDENTIFICATION_CODE (13), \
    COMPANY_IDENTIFICATION_CODE (14), \
    COMPANY_IDENTIFICATION_CODE (15), \
    COMPANY_IDENTIFICATION_CODE (16), \
    COMPANY_IDENTIFICATION_CODE (17), \
    COMPANY_IDENTIFICATION_CODE (18), \
    COMPANY_IDENTIFICATION_CODE (19), \
    COMPANY_IDENTIFICATION_CODE (20), \
    COMPANY_IDENTIFICATION_CODE (21), \
    COMPANY_IDENTIFICATION_CODE (22), \
    COMPANY_IDENTIFICATION_CODE (23), \
    COMPANY_IDENTIFICATION_CODE (24), \
    COMPANY_IDENTIFICATION_CODE (25), \
    COMPANY_IDENTIFICATION_CODE (26), \
    COMPANY_IDENTIFICATION_CODE (27), \
    COMPANY_IDENTIFICATION_CODE (28), \
    COMPANY_IDENTIFICATION_CODE (29), \
    COMPANY_IDENTIFICATION_CODE (30), \
    COMPANY_IDENTIFICATION_CODE (31), \
    COMPANY_IDENTIFICATION_CODE (32), \
    COMPANY_IDENTIFICATION_CODE (33), \
    COMPANY_IDENTIFICATION_CODE (34), \
    COMPANY_IDENTIFICATION_CODE (35), \
    COMPANY_IDENTIFICATION_CODE (36), \
    COMPANY_IDENTIFICATION_CODE (37), \
    COMPANY_IDENTIFICATION_CODE (38), \
    COMPANY_IDENTIFICATION_CODE (39), \
    COMPANY_IDENTIFICATION_CODE (40), \
    COMPANY_IDENTIFICATION_CODE (41), \
    COMPANY_IDENTIFICATION_CODE (42), \
    COMPANY_IDENTIFICATION_CODE (43), \
    COMPANY_IDENTIFICATION_CODE (44), \
    COMPANY_IDENTIFICATION_CODE (45), \
    COMPANY_IDENTIFICATION_CODE (46), \
    COMPANY_IDENTIFICATION_CODE (47), \
    COMPANY_IDENTIFICATION_CODE (48), \
    COMPANY_IDENTIFICATION_CODE (49), \
    COMPANY_IDENTIFICATION_CODE (50), \
    COMPANY_IDENTIFICATION_CODE (51), \
    COMPANY_IDENTIFICATION_CODE (52), \
    COMPANY_IDENTIFICATION_CODE (53), \
    COMPANY_IDENTIFICATION_CODE (54), \
    COMPANY_IDENTIFICATION_CODE (55), \
    COMPANY_IDENTIFICATION_CODE (56), \
    COMPANY_IDENTIFICATION_CODE (57), \
    COMPANY_IDENTIFICATION_CODE (58), \
    COMPANY_IDENTIFICATION_CODE (59), \
    COMPANY_IDENTIFICATION_CODE (60), \
    COMPANY_IDENTIFICATION_CODE (61), \
    COMPANY_IDENTIFICATION_CODE (62), \
    COMPANY_IDENTIFICATION_CODE (63), \
    COMPANY_IDENTIFICATION_CODE (64), \
    COMPANY_IDENTIFICATION_CODE (65), \
    COMPANY_IDENTIFICATION_CODE (66), \
    COMPANY_IDENTIFICATION_CODE (67), \
    COMPANY_IDENTIFICATION_CODE (68), \
    COMPANY_IDENTIFICATION_CODE (69), \
    COMPANY_IDENTIFICATION_CODE (70), \
    COMPANY_IDENTIFICATION_CODE (71), \
    COMPANY_IDENTIFICATION_CODE (72), \
    COMPANY_IDENTIFICATION_CODE (73), \
    COMPANY_IDENTIFICATION_CODE (74), \
    COMPANY_IDENTIFICATION_CODE (100), \
    COMPANY_IDENTIFICATION_CODE (108), \
    COMPANY_IDENTIFICATION_CODE (250), \
    COMPANY_IDENTIFICATION_CODE (251), \
    COMPANY_IDENTIFICATION_CODE (252), \
    COMPANY_IDENTIFICATION_CODE (253)

/* Common Tables Manufacturer codes, Revision 6 Additions, @ START (See @ END)
61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71
@ END */

/*
 * The reply message of an identify request is defined here as a macro because
 * the same reply is returned by command 0 and command 11 (the identify commands).
 */

#define IDENTIFY_REPLY \
	response_code, device_status, 254, manufacturer_id, device_type, \
	request_preambles, universal_revision, transmitter_revision, \
	software_revision, hardware_revision <0xf8>, physical_signaling_code <0x07>, \
	device_flags, device_id

VARIABLE response_code
{
  HELP [command_specific_response_code_help];
/*
  APPHELP "NOTE- HART Revisions < 5 had a different specification for this"
	  " variable."
	  " "
	  "The Following Applies to HART Revision >= 5"
	  " Command Specific Response Codes are encoded in bits #6 - #0 of the"
	  " first byte of the Response Codes. These codes are 7-bit unsigned"
	  " integers, have values ranging from 0 to 127, and are not bit-mapped."
	  " "
	  "The Command Specific Response Codes have symbolic meanings which"
	  " fall into the following basic types:"
	  " "
	  "Success- Command executed properly. All Data Bytes are"
	  "         included in the Slave response."
	  " "
	  "Warning- Command executed was completed with a deviation, and the"
	  "         is described in the Command Specific Response Code."
	  "         All Data Bytes are included in the Slave response."
	  " "
	  "    Warnings with singular definitions are assigned to Command"
	  "    Specific Response Codes: 24-27, 96-111."
	  "    NOTE- For HART Revision < 5 the following groupings were not"
	  "    maintained per these definitions."
	  " "
	  "    Warnings with multiple definitions are assigned to Command"
	  "    Specific Response Codes: 8, 14, 30, 31, 112-127."
	  "    NOTE- For HART Revision < 5 the following groupings were not"
	  "    maintained per these definitions."
	  " "
	  "Error- Command execution was not completed, as defined by the"
	  "       Command, and the Command Specific Response Code indicates the"
	  "       reason. Therefore the Host request caused no change to"
	  "       occur in the Slave."
	  "       No Data Bytes, other than the two Response Code"
	  "       Bytes, should be included in the Slave response."
	  " "
	  "These basic types are further broken down into specific"
	  " 'Response Code Types'. See the Device Description Language
	  " Specification for the definitions of these 'Response Code Types'."
	  " "
	  "    Errors with singular definitions are assigned to Command"
	  "    Specific  Response Codes: 0-7, 16-23, 32, 33-63, 64."
	  "    NOTE- For HART Revision < 5 the following groupings were not"
	  "    maintained per these definitions."
	  " "
	  "        Response Codes #32 and #64 may be returned in response to"
	  "        any command. Their definitions follow:"
	  " "
	  "            Response Code #32"
	  "                Busy- The Field Device is performing a function that"
	  "                cannot be interrupted by this command. The Command"
	  "                was not accepted."
	  " "
	  "            Response Code #64"
	  "                Command Not Implemented- The Command was not"
	  "                defined for this device. The Command was not"
	  "                accepted."
	  " "
	  "    Errors with multiple definitions are assigned to Command"
	  "    Specific Response Codes: 9-13, 15, 28, 29, 65-95."
	  "    NOTE- For HART Revision < 5 the following groupings were not"
	  "    maintained per these definitions."
	  " "
	  "NOTE- General definitions for Command Specific Response Codes"
	  "are located in the Document 'Appendix 1- Command Specific Response"
	  "Code Definitions'."
	  " "
	  "    NOTE- These assignments must be observed whenever new Command"
	  "    Specific Response Codes are defined and added to existing, or"
	  "    new, commands so that the Master can respond properly to the"
	  "    new code.";
	  " HART_VAR:Part of the Frame, RESP-CODE BYTE 1";
*/
  CLASS USER_INTERFACE & DIAGNOSTIC;
  TYPE ENUMERATED
    {
	{ 0, [success] }
    }
}

VARIABLE comm_status
{
  HELP [communications_error_summary_help];
/*
  APPHELP "No Data Bytes, other than the two Response Code"
	  "Bytes, should be included in the Slave response."
	  " "
	  "Bit #6  Vertical Parity Error- The parity of one or more of the"
	  "        bytes received by the device was incorrect."
	  " "
	  "Bit #5  Overrun Error- At least one byte of data in the receive"
	  "        buffer of the UART was overwritten before it was read."
	  " "
	  "Bit #4  Framing Error- The Stop Bit of one or more bytes received"
	  "        by the device was not detected by the UART."
	  " "
	  "Bit #3  Longitudinal Parity Error- The Longitudinal Parity"
	  "        calculated by the device did not match the Longitudinal"
	  "        Parity byte (Check Byte) at the end of the message."
	  " "
	  "Bit #2  Reserved, set to zero."
	  " "
	  "Bit #1  Buffer Overflow- The message was too long for the receive"
	  "        buffer of the device."
	  " "
	  "Bit #0  Undefined- Not defined at this time."
	  " "
	  " These specific bits can be given attributes called 'Cause Status"
	  " Classes'. See the Device Description Language Specification for the"
	  " definitions of these 'Cause Status Classes'."
	  " HART_VAR:Part of the Frame, RESP-CODE BYTE 1";
*/
  CLASS HART & DYNAMIC & DIAGNOSTIC;
  TYPE BIT_ENUMERATED
    {
	{ 0x02, [buffer_overflow],				HARDWARE & CORRECTABLE },
	{ 0x08, [longitudinal_parity_error],	HARDWARE & CORRECTABLE },
	{ 0x10, [framing_error],				HARDWARE & CORRECTABLE },
	{ 0x20, [overrun_error],				HARDWARE & CORRECTABLE },
	{ 0x40, [vertical_parity_error],		HARDWARE & CORRECTABLE }
    }
}

VARIABLE device_status
{
  HELP [field_device_status_help];
  LABEL	[device_status] ;
/*
  APPHELP "This condition does not affect the actions of the Command in the"
	  " Master request. Therefore, does not affect the number of Data Bytes"
	  " in the Slave response."
	  " The Communications Error Summary is a higher priority diagnostic."
	  " Therefore, the Field Device Status should not be evaluated by the"
	  " Host if a Communications Error Summary bit is set."
	  " These specific bits can be given attributes called 'Cause Status"
	  " Classes'. See the Device Description Language Specification for the"
	  " definitions of these 'Cause Status Classes'."
	  " HART_VAR:Part of the Frame, RESP-CODE BYTE 2";
*/
  CLASS HART & DYNAMIC & DIAGNOSTIC;
STYLE "MULTILINE 32 7";
  TYPE BIT_ENUMERATED
    {
    DEFAULT_VALUE 0;
    { 0x00, [ok]},
	{ 0x01, [PV_out_of_limits],	           DV1 (AUTO & BAD) },
	{ 0x02, [Non_PV_out_of_limits],        DV2 (AUTO & BAD) },
	{ 0x04, [PV_analog_output_saturated],  AO1 (AUTO & BAD) },
	{ 0x08, [PV_analog_output_fixed],      AO1 (MANUAL & GOOD) },
	{ 0x10, [more_status_available],       MORE },
//	{ 0x20, [cold_start],		           MISC },
	{ 0x40, [configuration_changed],       MISC & IGNORE_IN_HANDHELD },
	{ 0x80, [device_malfunction],	       MORE}
    }
}

#ifdef XXXX
VARIABLE manufacturer_id
{
  HELP [manufacturer_id_code_help];
/*
  APPHELP "For HART Revision >= 5
	  "    The long address of the frame is composed of the three variables"
	  "    manufacturer_id, device_type, and the device_id. The Long"
	  "    address is composed of 38 bits. The most significant bit is"
	  "    closest to the Delimiter Byte. Thus the least significant"
	  "    bit is located closest to the Command Byte. The least"
	  "    significant 6 bits of the variable manufacturer_id are mapped"
	  "    into the 6 most significant 6 bits of the long address. Note"
	  "    that the 2 most significant bits of the variable manufacturer_id"
	  "    are thrown away. The variable manufacturer_id is mapped into the"
	  "    next 8 most significant bits of the long address, and the"
	  "    device_id is mapped into the next 24 most significant bits of"
	  "    the long address."
	  " "
	  "    The variable manufacturer_id, combined with the variable"
	  "    device_type, will uniquely identify a type of Field Device. The"
	  "    combination of these two variables will have only one unique"
	  "    Device Description, though there may be revisions of the Device"
	  "    Description."
	  " "
	  "    The variable manufacturer_id, combined with the variable"
	  "    device_type, combined with the variable transmitter_revision,"
	  "    will identify the exact revision of the Device Description for"
	  "    this type of Field Device."
	  " "
	  "    The variable manufacturer_id, combined with the variable"
	  "    device_type, combined with the variable device_id, will"
	  "    uniquely identify a Field Device, such that there is only one"
	  "    such Field Device in the world."
	  " "
	  " NOTE- For HART Revision >= 5, the decimal numeric 254 that precedes"
	  " the manufacturer_id variable in Command #0 (i.e. one byte closer to"
	  " the Delimiter Byte), is part of an expansion mechanism that existed"
	  " for HART" Revisions < 5."
	  " NOTE- Rosemount Inc. subsidiaries should use their enumeration and"
	  " not 'Rosemount Inc.'.
	  " HART_VAR:MFR ID";
*/
  LABEL [manufacturer_id];
  HANDLING READ;
  CLASS HART;
  TYPE ENUMERATED
    {
	MANUFACTURER_CODES
    }
}
#endif
VARIABLE manufacturer_id
{
  HELP [manufacturer_id_code_help];
  LABEL [manufacturer_id];
  HANDLING READ;
  CLASS HART;
  TYPE ENUMERATED
    {
				COMPANY_IDENTIFICATION_CODE(108)
    }
}
// end redefiniton

#ifdef XXXX //redefined
VARIABLE device_type
{
  HELP [manufacturers_device_type_help];
/*
  APPHELP "This variable along with the variable manufacturer_id are used to"
	  " uniquely identify a Field Device. The combination of these two"
	  " variables will have only one unique Device Description. The"
	  " variable transmitter_revision is used to find the exact revision of"
	  " that unique Device Description."
	  " NOTE- The manufacturer must maintain a list of all these indexes."
	  " HART_VAR:MFR'S DEVICE TYPE";
*/
  LABEL [device_type];
  HANDLING READ;
  CLASS HART;
  TYPE ENUMERATED
    {
	SELECT (manufacturer_id) {
	CASE 17:						/* Endress and Hauser */
		{ 1, "FMU860" }

	CASE 19:						/* Fisher Controls */
		{ 1, "DT" },
		{ 2, "DVC" }

	CASE 21:						/* Fuji */
		{ 1, "FCX" }

	CASE 22:						/* Hartmann and Braun */
		{ 1, "AS800" }

	CASE 25:					 /* Kay Ray / Sensall */
		KAYRAY_MODEL_CODE(8), 	 /* Level 4050 */
		KAYRAY_MODEL_CODE(9),    /* Density 3680 */
		KAYRAY_MODEL_CODE(15)    /* Steam Quality 3280 */

	CASE 26:					 /* ABB Kent Taylor */
		{ 1,  [ABB_DPK_pressure] },
		{ 2,  [ABB_PX_pressure] },
		{ 8,  [ABB_DPK_temperature] },
		{ 16, [valve_positioner] },
		{ 24, [flow_device] },
		{ 32, [level_device] }

	CASE 31:					      /* Micro Motion */
		MICRO_MOTION_MODEL_CODE(7),   /* Massflow 9712 */
		MICRO_MOTION_MODEL_CODE(21)   /* Massflow 9739 */

	CASE 33:						/* Moore Products */
		{ 1, "340T" },
		{ 2, "340C" },
		{ 3, "344" }

	CASE 38:					   /* Rosemount */
		ROSEMOUNT_MODEL_CODE(1),   /* Pressure 3051 */
		ROSEMOUNT_MODEL_CODE(2),   /* Temperature 3044 */
		ROSEMOUNT_MODEL_CODE(3),   /* Pressure 1151s */
		ROSEMOUNT_MODEL_CODE(4),   /* Magnetic Flow 8712 */
		ROSEMOUNT_MODEL_CODE(5),   /* Pressure 2001 */
		ROSEMOUNT_MODEL_CODE(6),   /* Pressure 3051c */
		ROSEMOUNT_MODEL_CODE(11),  /* Pressure 3001l */
		ROSEMOUNT_MODEL_CODE(12),  /* Magnetic Flow 8712H */
		ROSEMOUNT_MODEL_CODE(13),  /* Temperature 3044C */
		ROSEMOUNT_MODEL_CODE(14),  /* Pressure 3001c */
		ROSEMOUNT_MODEL_CODE(15),  /* Pressure 3051clp */
		ROSEMOUNT_MODEL_CODE(16),  /* Vortex Flow 8800 */
		ROSEMOUNT_MODEL_CODE(17),  /* Hydrostatic Tank Gauge 3201 */
		ROSEMOUNT_MODEL_CODE(18),  /* Pressure 1152s */
		ROSEMOUNT_MODEL_CODE(19),  /* Hydrostatic Tank Gauge 3202 */
		ROSEMOUNT_MODEL_CODE(20)   /* Pressure 3001s */

	CASE 42:						/* Siemens */
		{ 1, "Siemens Micro K" },
		{ 2, "SITRANS L" },
		{ 3, "SIPAN PH" }
		{ 10, "SITRANS P"}

	CASE 43:					 /* Camille Bauer */
		{ 75, "75SMT" }

	CASE 46:					              /* Rosemount Analytical */
		ROSEMOUNT_ANALYTICAL_MODEL_CODE(6),   /* ph 2081 */
		ROSEMOUNT_ANALYTICAL_MODEL_CODE(7),   /* Conductivity 2081 */
		ROSEMOUNT_ANALYTICAL_MODEL_CODE(10),  /* ph 2054 */
		ROSEMOUNT_ANALYTICAL_MODEL_CODE(11)   /* Conductivity 2054 */

	CASE 55:
		{3,"UNIDELTA"}				/* Yokogawa */

	CASE 58:						/* Exac */
		{ 211, "8320" },
		{ 212, "SX5100" }

	CASE 63:						/*Eckardt */
		{ 1, "TSV175" },
		{ 2, "DMU" }

	CASE 66:						/* Samson */
		{ 1, "3780" }

	CASE 69:						/* Krohne */
		{ 0, "BM70" }
	}
	{ 253, [special] },
	{ 254, [expansion] }
    }
}
#endif
VARIABLE device_type
{
  HELP [manufacturers_device_type_help];
/*
  APPHELP "This variable along with the variable manufacturer_id are used to"
	  " uniquely identify a Field Device. The combination of these two"
	  " variables will have only one unique Device Description. The"
	  " variable transmitter_revision is used to find the exact revision of"
	  " that unique Device Description."
	  " NOTE- The manufacturer must maintain a list of all these indexes."
	  " HART_VAR:MFR'S DEVICE TYPE";
*/
  LABEL [device_type];
  HANDLING READ;
  CLASS HART;
  TYPE ENUMERATED
	{
				{ 0xec, "ES" }
	}
}
//end redefinition

VARIABLE request_preambles
{
  HELP [number_of_request_preambles_help];
/*
  APPHELP "The valid range of values is dependant on the technology of"
	  " the Hardware of the Physical Layer. The magnitude of this number"
	  " includes the two preambles required by the Data Link Layer."
	  " NOTE- This variable can affect the Data Link Layer."
	  " HART_VAR:NUMBER RQUEST PREAM";
*/
  LABEL [number_of_request_preambles];
  HANDLING READ;
  CLASS HART;
  TYPE UNSIGNED_INTEGER
    {
	MIN_VALUE  2;
	MAX_VALUE  20;
    }
}

VARIABLE universal_revision
{
  HELP [universal_revision_help];
/*
  APPHELP "The variable universal_revision in effect defines for the"
	  " Master how to interpret the valid Universal Command set, and also"
	  " how to send and receive the Universal Commands. Therefore, this"
	  " variable must be obtained from a Command #0 response to be able to"
	  " interpret any Universal Command. Thus to properly interpret any"
	  " Burst Mode response, the Master should know the Universal Revision"
	  " of that Slave."
	  " "
	  " NOTE- The HART Revision is a variable that is not available via the"
	  " protocol. This Revision identifies the a point in time where all"
	  " HART Documents were recorded, and was made available to Field Device"
	  " Developers as a valid set of documents for which to design a Field"
	  " Device to. Field Device Developers then can not pick and choose a"
	  " HART Document set at random."

	  " NOTE- For HART Revision <= 5 the following HART Specification"
	  " Revisions are not available via the protocol for the Physical Layer:"
	  " 'HART Physical Layer Specification'."

	  " NOTE- For HART Revision <= 5 the following HART Specification"
	  " Revisions are not available via the protocol for the Data Link"
	  " Layer: 'HART Data Link Layer Specification'."

	  " NOTE- For HART Revision <= 5 the following HART Specification"
	  " Revisions are not available via the protocol for the Application"
	  " Layer: 'HART Command Summary Information', 'HART Common"
	  " Practice Command Specification', 'HART Common Tables', 'HART"
	  " Appendix 1- Command Specific Response Code Definitions'."

	  " NOTE- A Field Device Description implicitly encodes the required"
	  " Application Layer Revisions that are required to communicate with"
	  " that Field Device."

	  " NOTE- If the Master attempts to communicate with a Field Device"
	  " that it does not have a Field Device Description for, it technically"
	  " has no way to ascertain the exact Common Practice Revision of Common"
	  " Tables Revision to utilize. It is possible by the variable"
	  " universal_revision to ascertain a minimum Common Practice Revision"
	  " and Common Tables Revision."

	  " NOTE- Value 254 is 'Reserved'."
	  " HART_VAR:UNIV CMD REV";
*/
  LABEL [universal_revision];
  HANDLING READ;
  CLASS HART;
  TYPE UNSIGNED_INTEGER
    {
	MAX_VALUE  253;
    }
}

VARIABLE transmitter_revision
{
  HELP [field_device_revision_help];
/*
  APPHELP "This variable in effect defines aspects of the Application"
	  " Layer, Data Link Layer, and Physical Layer, in that a HART Revision"
	  " was implicitly conformed to in the design of this Field Device"
	  " NOTE- Value 254 is 'Reserved'."
	  " HART_VAR:TRANS SPEC REV";
*/
  LABEL [transmitter_revision];
  HANDLING READ;
  CLASS HART;
  TYPE UNSIGNED_INTEGER
    {
	MAX_VALUE  253;
    }
}

VARIABLE software_revision
{
  HELP [field_device_software_revision_help];
/*
  APPHELP "For a specific value of the variable transmitter_revision the"
	  " variable software_revision be initiated at a value of '1'. This"
	  " count should be incremented for each released software modification."
	  " If the variable transmitter_revision is incremented the variable"
	  " software_revision be initiated once again to a value of '1', and so"
	  " forth. This variable could potentially be utilized as a handle for"
	  " recalling Field Devices with a software discrepancy."
	  " NOTE- Value 254 is 'Reserved'."
	  " HART_VAR:SOFT REV";
*/
  LABEL [software_revision];
  HANDLING READ;
  CLASS DEVICE;
  TYPE UNSIGNED_INTEGER
    {
	MAX_VALUE  253;
    }
}

VARIABLE hardware_revision
{
  HELP [hardware_revision_help];
/*
  APPHELP "The Field Device Hardware revision should be utilized"
	  " to track what ever level of modifications are desired. However,"
	  " please note the limited number of possible revisions. Also please"
	  " note that in many hardware / software configurations the software"
	  " can be removed from the hardware to be upgraded, moved, etc.. In"
	  " this situation the variable hardware_revision must not reside in the"
	  " software, but should be readable via from the actual hardware"
	  " itself."
	  " NOTE- Value 15 is Reserved for the Field Device Hardware Revision"
	  " component called the variable hardware_revision."
	  " HART_VAR:HARD REV";
*/
  LABEL [hardware_revision];
  HANDLING READ;
  CLASS DEVICE;
  TYPE UNSIGNED_INTEGER;
}

VARIABLE physical_signaling_code
{
  HELP [physical_signalling_code_help];
/*
  APPHELP "";
*/
  LABEL [physical_signalling_code];
  HANDLING READ;
  CLASS DEVICE;
  TYPE ENUMERATED
  {
      { 0, [bell_202_current] },
      { 1, [bell_202_voltage] },
      { 2, [rs_485] },
  }
}

VARIABLE device_flags
{
  HELP [field_device_flags_help];
/*
  APPHELP "NOTE- The enumeration '1' does not conform to the help description."
	  " HART_VAR:FLAGS";
*/
  LABEL [device_flags];
  HANDLING READ;
  CLASS HART;
  TYPE BIT_ENUMERATED
  {
	FLAG_ASSIGNMENT(0x01), /* Multisensor Device */
	FLAG_ASSIGNMENT(0x02), /* EEPROM Control */
	FLAG_ASSIGNMENT(0x04)  /* Protocol Bridge Device */
  }
}

VARIABLE device_id
{
  HELP [field_device_identification_help];
/*
  APPHELP "This variable should be written into the Field Device in the"
	  " manufacturing process. This variable should be initiated at value"
	  " '1' and incremented for each Field Device created that has the"
	  " same set of values for the variables manufacturer_id and"
	  " device_type."
	  " HART_VAR:DEVICE ID NUMBER";
*/
  LABEL [device_identification];
  HANDLING READ;
  CLASS HART;
  TYPE UNSIGNED_INTEGER (3);
}

COMMAND read_unique_identifier
{
	NUMBER 0;

	OPERATION READ;

	TRANSACTION
		{
			REQUEST
				{}

			REPLY
				{
					IDENTIFY_REPLY
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,	[no_command_specific_errors];
			6,	MISC_ERROR,	[xmtr_specific_command_error];
			16,	MODE_ERROR,	[access_restricted];
		}
}

COMMAND read_pv
{
	NUMBER 1;

	OPERATION READ;

	TRANSACTION
		{
			REQUEST
				{}

			REPLY
				{
					response_code, device_status, PV.DIGITAL_UNITS, PV.DIGITAL_VALUE
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,		[no_command_specific_errors];
			6,	MISC_ERROR,		[xmtr_specific_command_error];
			8,	MISC_WARNING,	[update_failure];
			16,	MODE_ERROR,		[access_restricted];
		}
}

COMMAND read_pv_current_and_percent_range
{
	NUMBER 2;

	OPERATION READ;

	TRANSACTION
		{
			REQUEST
				{}

			REPLY
				{
					response_code, device_status, PV.ANALOG_VALUE, PV.PERCENT_RANGE
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,		[no_command_specific_errors];
			6,	MISC_ERROR,		[xmtr_specific_command_error];
			8,	MISC_WARNING,	[update_failure];
			16,	MODE_ERROR,		[access_restricted];
		}
}

COMMAND read_dynamic_variables_and_pv_current
{
	NUMBER 3;

	OPERATION READ;

	TRANSACTION
		{
			REQUEST
				{}

#ifdef XXXX
			REPLY
				{
					response_code, device_status,
					PV.ANALOG_VALUE,
					PV.DIGITAL_UNITS, PV.DIGITAL_VALUE,
					SV.DIGITAL_UNITS, SV.DIGITAL_VALUE,
					TV.DIGITAL_UNITS, TV.DIGITAL_VALUE,
					QV.DIGITAL_UNITS, QV.DIGITAL_VALUE
				}
#else
			REPLY
				{
					response_code, device_status,
					PV.ANALOG_VALUE, PV.DIGITAL_UNITS, PV.DIGITAL_VALUE
					SV.DIGITAL_UNITS, SV.DIGITAL_VALUE
				}
#endif
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,		[no_command_specific_errors];
			6,	MISC_ERROR,		[xmtr_specific_command_error];
			8,	MISC_WARNING,	[update_failure];
			16,	MODE_ERROR,		[access_restricted];
		}
}

VARIABLE polling_address
{
  HELP [polling_address_help];
/*
  APPHELP "NOTE- This variable can affect the Data Link Layer."
	  " NOTE- This variable can affect the Multidrop Mode in the Field"
	  " Device. Value > 0 enables the Multidrop Mode for"
	  " Analog Output 1)."
	  " NOTE- This variable can affect the Analog Output Fixed Mode in the"
	  " Field Device." Value > 0 enables the Analog Output Fixed Mode for
	  " Analog Output 1)."
	  " HART_VAR:POLL ADDR";
*/
  LABEL [polling_address];
  HANDLING WRITE;
  CLASS HART;
  TYPE UNSIGNED_INTEGER
    {
	MAX_VALUE 15;
    }
}

COMMAND write_polling_address
{
	NUMBER 6;

	OPERATION WRITE;

	TRANSACTION
		{
			REQUEST
				{
					polling_address
				}

			REPLY
				{
					response_code, device_status, polling_address
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,			[no_command_specific_errors];
			2,	DATA_ENTRY_ERROR,	[invalid_selection];
			5,	MISC_ERROR,			[too_few_data_bytes_recieved];
			6,	MISC_ERROR,			[xmtr_specific_command_error];
			7,	MODE_ERROR,			[in_write_protect_mode];
			16,	MODE_ERROR,			[access_restricted];
		}
}

VARIABLE tag
{
  HELP [tag_help];
/*
  APPHELP "HART_VAR:TAG";
*/
  LABEL [tag];
  CLASS DEVICE;
  TYPE PACKED_ASCII (8);
}

COMMAND read_unique_identifier_with_tag
{
	NUMBER 11;

	OPERATION COMMAND;

	TRANSACTION
		{
			REQUEST
				{
					tag
				}

			REPLY
				{
					IDENTIFY_REPLY
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,	[no_command_specific_errors];
			5,	MISC_ERROR,	[too_few_data_bytes_recieved];
			6,	MISC_ERROR,	[xmtr_specific_command_error];
			16,	MODE_ERROR,	[access_restricted];
		}
}

VARIABLE message
{
  HELP [message_help];
/*
  APPHELP "HART_VAR:MESSAGE";
*/
  LABEL [message];
  CLASS DEVICE;
  TYPE PACKED_ASCII (32);
}

COMMAND read_message
{
	NUMBER 12;

	OPERATION READ;

	TRANSACTION
		{
			REQUEST
				{}

			REPLY
				{
					response_code, device_status, message
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,	[no_command_specific_errors];
			6,	MISC_ERROR,	[xmtr_specific_command_error];
			16,	MODE_ERROR,	[access_restricted];
		}
}

VARIABLE descriptor
{
  HELP [discriptor_help];
/*
  APPHELP "HART_VAR:DESCR";
*/
  LABEL [descriptor];
  CLASS DEVICE;
  TYPE PACKED_ASCII (16);
}

VARIABLE date
{
  HELP [date_help];
/*
  APPHELP "Format: Byte Closest to the Delimiter: Day, Next Byte: Month,
	  " Byte Furthest from the Delimiter: Year-1900.
	  " HART_VAR:DATE";
*/
  LABEL [date];
  CLASS DEVICE;
  TYPE DATE;
}

COMMAND read_tag_descriptor_date
{
	NUMBER 13;

	OPERATION READ;

	TRANSACTION
		{
			REQUEST
				{}

			REPLY
				{
					response_code, device_status, tag, descriptor, date
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,	[no_command_specific_errors];
			6,	MISC_ERROR, [xmtr_specific_command_error];
			16,	MODE_ERROR, [access_restricted];
		}
}

COMMAND read_pv_sensor_info
{
	NUMBER 14;

	OPERATION READ;

	TRANSACTION
		{
			REQUEST
				{}

			REPLY
				{
					response_code, device_status,
					PV.SENSOR_SERIAL_NUMBER, PV.SENSOR_UNITS,
					PV.UPPER_SENSOR_LIMIT, PV.LOWER_SENSOR_LIMIT,
					PV.MINIMUM_SPAN
				}
		}

	RESPONSE_CODES
		{
			0, SUCCESS,	[no_command_specific_errors];
			6,	MISC_ERROR, [xmtr_specific_command_error];
			16,	MODE_ERROR, [access_restricted];
		}
}

VARIABLE write_protect
{
  HELP [write_protect_mode_help];
/*
  APPHELP "Common uses for the write_protect variable are to limit user access"
	  " for Field Devices installed in custody transfer applications."
	  " HART_VAR:WRITE PROT CODE";
*/
  LABEL [write_protect];
  HANDLING READ;
  CLASS DEVICE;
  TYPE ENUMERATED
    {
		{ 0,	[not_write_protected] },
		{ 1,	[write_protected] },
		{ 250,	[not_used] },
		{ 251,	[none] },
		{ 252,	[unknown] },
		{ 253,	[special] }
    }
}

VARIABLE private_label_distributor
{
  HELP [private_label_distributor_help];
/*
  APPHELP "This variable may or may not be the same as the variable"
	  " manufacturer_id."
	  " NOTE- Rosemount Inc. subsidiaries should use their enumeration and"
	  " not 'Rosemount Inc.'.
	  " HART_VAR:PVT LABEL DIST CODE";
*/
  LABEL [private_label_distributor];
  HANDLING READ;
  CLASS DEVICE;
  TYPE ENUMERATED
    {
	MANUFACTURER_CODES
    }
}

COMMAND read_pv_output_info
{
	NUMBER 15;

	OPERATION READ;

	TRANSACTION
		{
			REQUEST
				{}

			REPLY
				{
					response_code, device_status,
					PV.ALARM_CODE, PV.TRANSFER_FUNCTION,
					PV.RANGE_UNITS, PV.UPPER_RANGE_VALUE, PV.LOWER_RANGE_VALUE,
					PV.DAMPING_VALUE, write_protect, private_label_distributor
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,	[no_command_specific_errors];
			6,	MISC_ERROR, [xmtr_specific_command_error];
			16,	MODE_ERROR, [access_restricted];
		}
}

VARIABLE final_assembly_number
{
  HELP [final_assembly_number_help];
/*
  APPHELP "For Universal Revision < 5
	  "  If the decimal numeric 254 that precedes"
	  "  the manufacturer_id variable in Command #0 (i.e. one byte closer"
	  "  to the Delimiter Byte), that is part of an expansion mechanism"
	  "  is used."
	  ""
	  "    The variable manufacturer_id, combined with the variable"
	  "    device_type, will uniquely identify a type of Field Device. The"
	  "    combination of these two variables will have only one unique "
	  "    Device Description, though there may be revisions of the Device"
	  "    Description."
	  ""
	  "    The variable manufacturer_id, combined with the variable"
	  "    device_type, combined with the variable transmitter_revision,"
	  "    will identify the exact revision of the Device Description for"
	  "    this type of Field Device."
	  ""
	  "    The variable manufacturer_id, combined with the variable"
	  "    device_type, combined with the variable final_assembly_number,"
	  "    will possibly uniquely identify a Field Device. The word"
	  "    'possibly' was used since the variable final_assembly_number is"
	  "    modifiable by the protocol."
	  ""
	  "  If the decimal numeric 254 that would precede"
	  "  the manufacturer_id variable in Command #0 (i.e. one byte closer"
	  "  to the Delimiter Byte), that is part of an expansion mechanism"
	  "  is not used."
	  ""
	  "    The variable manufacturer_id, is not present and is therefore"
	  "    assumed to be 'Rosemount Inc.'."
	  ""
	  "    The variable device_type, combined with the variable"
	  "    transmitter_revision, will identify the exact revision of the"
	  "    Device Description for this type of 'Rosemount Inc. Field"
	  "    Device."
	  ""
	  "    The variable device_type, combined with the variable"
	  "    transmitter_revision, combined with the variable"
	  "    final_assembly_number, will possibly uniquely identify a Field"
	  "    Device. The word" 'possibly' was used since the variable"
	  "    final_assembly_number is" modifiable by the protocol."
	  ""
	  "NOTE- The variable final_assembly_number in Command #0 of Universal"
	  "Revision < 5, was replaced by the variable device_type in Command #0"
	  "of Universal Revision > 5."
	  "HART_VAR:FINAL ASS'Y NUMBER";
*/
  LABEL [final_assembly_number];
  CLASS DEVICE;
  TYPE UNSIGNED_INTEGER (3)
    {
	MAX_VALUE 16777215;
	EDIT_FORMAT "8u" ;
    }
}

COMMAND read_final_assembly_number
{
	NUMBER 16;

	OPERATION READ;

	TRANSACTION
		{
			REQUEST
				{}

			REPLY
				{
					response_code, device_status, final_assembly_number
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,	[no_command_specific_errors];
			6,	MISC_ERROR, [xmtr_specific_command_error];
			16,	MODE_ERROR, [access_restricted];
		}
}

COMMAND write_message
{
	NUMBER 17;

	OPERATION WRITE;

	TRANSACTION
		{
			REQUEST
				{
					message
				}

			REPLY
				{
					response_code, device_status, message
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,	[no_command_specific_errors];
			5,	MISC_ERROR, [too_few_data_bytes_recieved];
			6,	MISC_ERROR, [xmtr_specific_command_error];
			7,	MODE_ERROR, [in_write_protect_mode];
			16,	MODE_ERROR, [access_restricted];
		}
}

COMMAND write_tag_descriptor_date
{
	NUMBER 18;

	OPERATION WRITE;

	TRANSACTION
		{
			REQUEST
				{
					tag, descriptor, date
				}

			REPLY
				{
					response_code, device_status, tag, descriptor, date
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,	[no_command_specific_errors];
			5,	MISC_ERROR, [too_few_data_bytes_recieved];
			6,	MISC_ERROR, [xmtr_specific_command_error];
			7,	MODE_ERROR, [in_write_protect_mode];
			16,	MODE_ERROR, [access_restricted];
		}
}

COMMAND write_final_assembly_number
{
	NUMBER 19;

	OPERATION WRITE;

	TRANSACTION
		{
			REQUEST
				{
					final_assembly_number
				}

			REPLY
				{
					response_code, device_status, final_assembly_number
				}
		}

	RESPONSE_CODES
		{
			0,	SUCCESS,	[no_command_specific_errors];
			5,	MISC_ERROR, [too_few_data_bytes_recieved];
			6,	MISC_ERROR, [xmtr_specific_command_error];
			7,	MODE_ERROR, [in_write_protect_mode];
			16,	MODE_ERROR, [access_restricted];
		}
}
