/*
 * HART Device Description Macro Definitions
 *
 *	@(#)macros.h	1.1 2/7/95
 *
 *	This file should be included in each HART DDL which uses the new
 *	way of implementing builtins.
 *
 */
#define USER_INTERFACE LOCAL
#define LOCAL_INTERFACE LOCAL_DISPLAY

#define I_NO_COMMAND_SPECIFIC_ERRORS	 0
#define I_INVALID_SELECTION				 2
#define I_PARAMETER_TOO_LARGE			 3
#define I_PARAMETER_TOO_SMALL			 4
#define I_TOO_FEW_DATA_BYTES			 5
#define I_TRANSMITTER_SPECIFIC_ERROR	 6
#define I_IN_WRITE_PROTECT_MODE			 7
#define I_ACCESS_RESTRICTED				16

/*
 * Strings for the single definition response codes.
 */

#define S_NO_COMMAND_SPECIFIC_ERRORS [no_command_specific_errors]
#define S_INVALID_SELECTION [invalid_selection]
#define S_PARAMETER_TOO_LARGE [passed_parameter_too_large]
#define S_PARAMETER_TOO_SMALL [passed_parameter_too_small]
#define S_TOO_FEW_DATA_BYTES [too_few_data_bytes_recieved]
#define S_TRANSMITTER_SPECIFIC_ERROR [xmtr_specific_command_error]
#define S_IN_WRITE_PROTECT_MODE [in_write_protect_mode]
#define S_ACCESS_RESTRICTED [access_restricted]

#define PRIMARY		1
#define SECONDARY	2
#define TERTIARY	3
#define FOURTH		4

#define PV  dynamic_variables[PRIMARY]
#define SV  dynamic_variables[SECONDARY]
#define TV  dynamic_variables[TERTIARY]
#define QV  dynamic_variables[FOURTH]

/*
 * Common table references.
 */

#define ROSEMOUNT_MODEL_CODE(N) { N, rosemount_model_code(N) }
#define ROSEMOUNT_ANALYTICAL_MODEL_CODE(N) { N, rosemount_analytical_model_code(N) }
#define KAYRAY_MODEL_CODE(N) { N, kayray_model_code(N) }
#define MICRO_MOTION_MODEL_CODE(N) { N, micro_motion_model_code(N) }
#define UNITS_CODE(N) { N, units_code(N) }
#define TRANSFER_FUNCTION_CODE(N) { N, transfer_function_code(N) }
#define MATERIAL_CODE(N) { N, material_code(N) }
#define ALARM_SELECTION_CODE(N) { N, alarm_selection_code(N) }
#define WRITE_PROTECT_CODE(N) { N, write_protect_code(N) }
#define COMPANY_IDENTIFICATION_CODE(N) { N, company_identification_code(N) }
#define BURST_MODE_CONTROL_CODE(N) { N, burst_mode_control_code(N) }
#define PHYSICAL_SIGNALING_CODE(N) { N, physical_signaling_codes(N) }
#define FLAG_ASSIGNMENT(N) { N, flag_assignment(N) }
#define OPERATING_MODE_CODE(N) { N, operating_mode_code(N) }
#define ANALOG_OUTPUT_NUMBERS_CODE(N) { N, analog_output_numbers_code(N) }


